-----------------------------------------------------------------------------------------------
-- Client Lua Script for ViragsAutoCircuit
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- ViragsAutoCircuit Module Definition
-----------------------------------------------------------------------------------------------

------------!-------------------------------------------------------------------!-------
------------!-- WARNING! THE CODE IS VERY MESSY! DON'T HAVE TIME TO REFACTOR! --!-------
------------!-------------------------------------------------------------------!-------
--TODO refactor code

local ViragsAutoCircuit = {} 
ViragsAutoCircuit.Count = 0
ViragsAutoCircuit.Stop = false 

local SoketIndex = 0
local PickerIndex = 0
local PropertyIndex = 0
local bHasEnoughMaterials = false
local tDesiredPowerCoreTypes = { "Weak ", "Rough ", "" }
local craftQueIndex = 1
local Sokets = {}
local Property = {}
local Picker = {}
ViragsAutoCircuit.Power = {}
ViragsAutoCircuit.PowerIndex = 0


SoketRecording = true
bRepeatLastCraft = false
nLastCraftSchemId = nil

ViragsAutoCircuit.RandomProperty = {}
ViragsAutoCircuit.RandomPropertyIndex = 0
ViragsAutoCircuit.IsRandomFailed = false


local SavedConfig = {}
local knTopLevelHeight = 0
local listItemIndex 
local listItemParent 
local selectedListItem
local itemHeight = 0
local IsCraftingQue = false
local IsCraftingQueItem = false
local bUseDesiredCore = false
local bAbandonOnDesired = false
local bCountRuneSlots = false
local nRuneCount = 1
local bStayOnTop = false
local bTargetItemLooted = false
local nCurrentItemIndex = nil

local wndSize = 1

local tWndSpecials
local tDesiredSpecials
local nMode
local tWndDesiredPowers
local tDesiredCores
local tCurPatterns
local wndNames = { {patternList = "ItemPatterns" ,listItem = "PatternListItem"},
 { patternList = "ItemPatternsMini" , listItem = "PatternListItemMini"} }
--todo refactor
local wndTitles = { {"Dailies Helper Queue", "Dailies Helper Queue" } , { "Schematics Queue", "Schematics Queue" }}
local tTempQueue


local kTradeskills =
{
	[CraftingLib.CodeEnumTradeskill.Survivalist]	=	{strName = "Survivalist",	strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_Survivalist"},
	[CraftingLib.CodeEnumTradeskill.Architect]		=	{strName = "Architect",		strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_Architect"},
	[CraftingLib.CodeEnumTradeskill.Fishing]		=	{strName = "Fishing",		strIcon = ""},
	[CraftingLib.CodeEnumTradeskill.Mining]			=	{strName = "Mining",		strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_Miner"},
	[CraftingLib.CodeEnumTradeskill.Relic_Hunter]	=	{strName = "Relic Hunter",	strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_RelicHunter"},
	[CraftingLib.CodeEnumTradeskill.Cooking]		=	{strName = "Cooking",		strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_Cooking"},
	[CraftingLib.CodeEnumTradeskill.Outfitter]		=	{strName = "Outfitter",		strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_Outfitter"},
	[CraftingLib.CodeEnumTradeskill.Armorer]		=	{strName = "Armorer",		strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_Armorer"},
	[CraftingLib.CodeEnumTradeskill.Farmer]			=	{strName = "Farmer",		strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_Farmer"},
	[CraftingLib.CodeEnumTradeskill.Weaponsmith]	=	{strName = "Weaponsmith",	strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_WeaponCrafting"},
	[CraftingLib.CodeEnumTradeskill.Tailor]			=	{strName = "Tailor",		strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_Tailor"},
	[CraftingLib.CodeEnumTradeskill.Runecrafting]	=	{strName = "Runecrafting",	strIcon = ""},
	[CraftingLib.CodeEnumTradeskill.Augmentor]		=	{strName = "Technologist",	strIcon = "IconSprites:Icon_Achievement_UI_Tradeskills_Technologist"},
}
local kTradeskillTiers =
{
	[CraftingLib.CodeEnumTradeskillTier.Zero]			=	"-",
	[CraftingLib.CodeEnumTradeskillTier.Apprentice]		=	"Apprentice",
	[CraftingLib.CodeEnumTradeskillTier.Artisan]		=	"Artisan",
	[CraftingLib.CodeEnumTradeskillTier.Expert]			=	"Expert",
	[CraftingLib.CodeEnumTradeskillTier.GrandMaster]	=	"Grandmaster",
	[CraftingLib.CodeEnumTradeskillTier.Journeyman]		=	"Journeyman",
	[CraftingLib.CodeEnumTradeskillTier.Master]			=	"Master",
	[CraftingLib.CodeEnumTradeskillTier.Novice]			=	"Novice",
}

local karPowerCoreTierToString =
{
	[CraftingLib.CodeEnumTradeskillTier.Novice] 	= Apollo.GetString("CRB_Tradeskill_Quartz"),
	[CraftingLib.CodeEnumTradeskillTier.Apprentice] = Apollo.GetString("CRB_Tradeskill_Sapphire"),
	[CraftingLib.CodeEnumTradeskillTier.Journeyman] = Apollo.GetString("CRB_Tradeskill_Diamond"),
	[CraftingLib.CodeEnumTradeskillTier.Artisan] 	= Apollo.GetString("CRB_Tradeskill_Chrysalus"),
	[CraftingLib.CodeEnumTradeskillTier.Expert] 	= Apollo.GetString("CRB_Tradeskill_Starshard"),
	[CraftingLib.CodeEnumTradeskillTier.Master] 	= Apollo.GetString("CRB_Tradeskill_Hybrid"),
}


-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
local PATTERN_LIST_SMALL = 2
local PATTERN_LIST_BIG = 1
local MODE_DAILIES = 1
local MODE_SCHEMATICS = 2
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function ViragsAutoCircuit:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function ViragsAutoCircuit:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		"Lib:ApolloFixes-1.0",
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- ViragsAutoCircuit OnLoad
-----------------------------------------------------------------------------------------------
function ViragsAutoCircuit:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("ViragsAutoCircuit.xml")
	self.wndMain = Apollo.LoadForm(self.xmlDoc, "ViragsAutoCircuitForm", nil, self)
	if self.wndMain == nil then
		Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
		return
	end

	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- ViragsAutoCircuit OnDocLoaded
-----------------------------------------------------------------------------------------------
function ViragsAutoCircuit:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    		
	    self.wndMain:Show(false)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		--Apollo.RegisterSlashCommand("vac", "OnViragsAutoCircuitOn", self)
		Apollo.RegisterEventHandler("GenericEvent_StartCircuitCraft", "OnCircuitOpen", self)
		Apollo.RegisterEventHandler("CraftingInterrupted",	"OnViragsAutoCircuitStop", self)
		Apollo.RegisterEventHandler("GenericEvent_InitializeSchematicsTree", "OnInitializeSchematicsTree", self)
		Apollo.RegisterEventHandler("ObscuredAddonVisible", "OnObscuredAddonVisible", self)
		Apollo.RegisterEventHandler("CloseVendorWindow",	"AddPattern", self)
		Apollo.RegisterEventHandler("ToggleTradeskills", "OnToggleTradeskills", self)
		Apollo.RegisterEventHandler("LootedItem", "OnLootedItem", self)
		Apollo.RegisterEventHandler("GenericEvent_BotchCraft", 	"OnAbandonCraft", self)


		bHasEnoughMaterials = false
		--wndSize = 1
		--wndNames = { {patternList = "ItemPatterns" ,listItem = "PatternListItem"},
 		--{ patternList = "ItemPatternsMini" , listItem = "PatternListItemMini"} }

		-- Do additional Addon initialization here
		self.wndItems = self.wndMain:FindChild("ItemsNumber")
		self.wndAttrStep = self.wndMain:FindChild("PickerStep")
		self.wndRuneCount = self.wndMain:FindChild("SpecialsMain"):FindChild("ItemsNumber")
		self.SpecialProperty = {}
		self.SpecialPropertyIndex = 0
		bRepeatLastCraft = false
		
		IsCraftingQue = false
		IsCraftingQueItem = false
		if nMode == nil then nMode = MODE_DAILIES end
		
		if tDesiredSpecials == nil then tDesiredSpecials = {} end
		if tDesiredCores == nil then tDesiredCores = {} end
		self.tSchematicSpecials = {}
		if bUseDesiredCore ~= nil then 
			self.wndMain:FindChild("DesiredPowerCheckBox"):SetCheck(bUseDesiredCore)
		end
		--[[if bAbandonOnDesired ~= nil then
			self.wndMain:FindChild("AbandonCraftCheckBox"):SetCheck(bAbandonOnDesired)
		end]]
		if bCountRuneSlots ~= nil then
			self.wndMain:FindChild("RuneSlotsCheckbox"):SetCheck(bCountRuneSlots)
		end
		
		if nRuneCount ~= 1 then
			self.wndRuneCount:SetText(nRuneCount)
		end


		if bStayOnTop ~= nil then
			self.wndMain:FindChild("StayOnTopCheckBox"):SetCheck(bStayOnTop)
		end
		
		tWndSpecials = {}
		for id = 1, 4 do
			tWndSpecials[id] = self.wndMain:FindChild("Special" .. id)
			tWndSpecials[id]:SetData(id)
		end
		
		tWndDesiredPowers = {}
		for id = 1, 3 do
			tWndDesiredPowers[id] = self.wndMain:FindChild("PowerCore" .. id)
			tWndDesiredPowers[id]:SetData(id)
			if tDesiredCores[id] ~= nil then 
				tWndDesiredPowers[id]:SetCheck(true)
				tWndDesiredPowers[id]:FindChild("IsChecked"):Show(true)
			end
		end
		if not self.SavedPatterns then self.SavedPatterns = {} end	
		if not self.SavedConfig then self.SavedConfig = {} end	
		self:ChangeQueueState()
		self:SwitchCurrentPatterns(nMode)	
	end
end

function ViragsAutoCircuit:SwitchCurrentPatterns( nCurMode)
	if nCurMode == MODE_DAILIES then
		tCurPatterns = self.SavedConfig
	else
		tCurPatterns = self.SavedPatterns
	end
end

-----------------------------------------------------------------------------------------------
-- ViragsAutoCircuit Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

function ViragsAutoCircuit:OnLootedItem(item, nCount)
	if self.wndMain:IsVisible() then
		local tRuneSlots = item:GetRuneSlots()	
		if tRuneSlots ~= nil and tRuneSlots.bIsDefined then
			nRuneCount = tonumber(self.wndRuneCount:GetText())
			if bCountRuneSlots == true and #item:GetRuneSlots().arRuneSlots == nRuneCount then
				
				bTargetItemLooted = true
			end
		end 
	end
end


function ViragsAutoCircuit:PRINT(msg)
    if msg == nil then return end
    ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_System, msg, "Virag's Auto Circuit")
end

function ViragsAutoCircuit:OnToggleAutoCircuit( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
	if self.wndMain:IsVisible() then
		self.wndMain:Show(false)
		
	else 
		self.wndMain:Show(true)
		self.wndMain:ToFront()
	end

end


function ViragsAutoCircuit:OnViragsAutoCircuitOn()
	--self.wndMain:Invoke()
	--self.wndMain:Show(true)
    Apollo.GetAddon("Crafting").luaSchematic.OnPropertyBtn = self.OnPropertyBtn;
	Apollo.GetAddon("Crafting").luaSchematic.OnPowerCoreItemBtn = self.OnPowerCoreItemBtn;
	Apollo.GetAddon("Crafting").luaSchematic.OnCircuitPickerLeftRight = self.OnCircuitPickerLeftRight;
	Apollo.GetAddon("Crafting").luaSchematic.GetSystemSocketItem = self.GetSystemSocketItem;
	Apollo.GetAddon("Crafting").OnPreviewStartCraft = self.OnPreviewStartCraft;
	if bStayOnTop == true then Apollo.GetAddon("Crafting").wndMain:SetStyle("NeverBringToFront",true) end
end

function ViragsAutoCircuit:OnCloseTradeskills(wndHandler, wndControl)
	--[[if wndHandler == wndControl then
		local v = Apollo.GetAddon("ViragsAutoCircuit")
		v.wndMain:Show(false)
		self.wndMain:Show(false)
	end]]
end

function ViragsAutoCircuit:OnToggleTradeskills()
	--self.timer = ApolloTimer.Create(0.2, false, "OnToggleWait", self)
	--self.timer:Start()
	
end

function ViragsAutoCircuit:OnToggleWait()
	local t = Apollo.GetAddon("TradeskillContainer")
	--self.wndMain:Show(t.wndMain:IsVisible())
end



function ViragsAutoCircuit:OnInitializeSchematicsTree()	
	--self.wndMain:Show(true)
	--self.wndMain:ToFront()
	self:AttachtTradeskillsOverlay()
	self:AddPattern()
end

local wndSokets = {}
local wndSocketsIndex = 0

function ViragsAutoCircuit:OnPreviewStartCraft(wndHandler, wndControl, idNSchematic) -- PreviewStartCraftBtn, data is idSchematic
	local viragsAutoCircuit = Apollo.GetAddon("ViragsAutoCircuit")
	if viragsAutoCircuit.Stop == true then 
		viragsAutoCircuit:OnClearSokets() 
		viragsAutoCircuit:PRINT("Recorded item cleared.")
	end
	
		
	local idSchematic = nil
	if idNSchematic ~= nil and idNSchematic ~= 0 then
		idSchematic = idNSchematic
	else
		idSchematic = wndHandler:GetData()
	end
	nLastCraftSchemId = idSchematic
	local tCurrentCraft = CraftingLib.GetCurrentCraft()
	if not tCurrentCraft or tCurrentCraft.nSchematicId == 0 then -- Start if it hasn't started already (i.e. just clicking craft button)
		CraftingLib.CraftItem(idSchematic)
		viragsAutoCircuit:ChangeCircuitBoardOverlayMode()
	end
	self.wndMain:FindChild("PostCraftBlocker"):Show(false)
	Event_FireGenericEvent("GenericEvent_StartCircuitCraft", idSchematic)
end

function ViragsAutoCircuit:GetSystemSocketItem(nSocket)
	
	local viragsAutoCircuit = Apollo.GetAddon("ViragsAutoCircuit")
	-- get the server selected random chip
	local tCurrentCraft = CraftingLib.GetCurrentCraft()
	

	if tCurrentCraft and tCurrentCraft.tMicrochips and tCurrentCraft.tMicrochips[nSocket].itemChip then
		local checker = false
		for k, v in pairs(viragsAutoCircuit.RandomProperty) do
			if v.s == nSocket then
				v.n = tCurrentCraft.tMicrochips[nSocket].itemChip:GetName()
				v.p = tCurrentCraft.tMicrochips[nSocket].itemChip:GetDetailedInfo().tPrimary.tChipInfo.eProperty
				if v.n == "Random" then v.p = -1 end
				checker = true
			end
		end
		if not checker then 
			viragsAutoCircuit.RandomPropertyIndex = viragsAutoCircuit.RandomPropertyIndex + 1
			local tItem = tCurrentCraft.tMicrochips[nSocket].itemChip:GetDetailedInfo().tPrimary.tChipInfo.eProperty
			--viragsAutoCircuit.RandomProperty[viragsAutoCircuit.RandomPropertyIndex] = { n = tCurrentCraft.tMicrochips[nSocket].itemChip:GetName(), s = nSocket, i = viragsAutoCircuit.RandomPropertyIndex}
			viragsAutoCircuit.RandomProperty[viragsAutoCircuit.RandomPropertyIndex] = { 
			n = tCurrentCraft.tMicrochips[nSocket].itemChip:GetName(), p = tItem, s = nSocket, i = viragsAutoCircuit.RandomPropertyIndex}			
			if tCurrentCraft.tMicrochips[nSocket].itemChip:GetName() == "Random" then
				viragsAutoCircuit.RandomProperty[viragsAutoCircuit.RandomPropertyIndex].p = -1
			end
		end

		return tCurrentCraft.tMicrochips[nSocket].itemChip
	end
	-- get the static defined chip
	if tCurrentCraft and self.tSchematicInfo.tSockets[nSocket].itemDefaultChip then
		return self.tSchematicInfo.tSockets[nSocket].itemDefaultChip
	end
	return nil
end


function ViragsAutoCircuit:OnPropertyBtn(wndHandler, wndControl, craftingQue, tSavedValues ) -- PropertyPickerAlphaBtn or PropertyPickerBetaBtn or PropertyPickerGammaBtn
	local altself = self
	local viragsAutoCircuit = Apollo.GetAddon("ViragsAutoCircuit")
	local isRandomChecked = viragsAutoCircuit.wndMain:FindChild("PropertyCheckBox"):IsChecked()
	local pickerStep = tonumber(viragsAutoCircuit.wndMain:FindChild("PickerStep"):GetText())
	if craftingQue == true and tSavedValues[5] == nul then 
		isRandomChecked = true 
	end
	--local altself = Apollo.GetAddon("Crafting").luaSchematic
	local wndSocket
	local eProperty
	local nLayoutLoc
	if wndHandler == nul or wndHandler:GetData() == nul then
		wndSocket = tSavedValues[1] 
		eProperty = tSavedValues[2]
		nLayoutLoc = tSavedValues[3]
	else
		wndSocket = wndHandler:GetData()[1]
		eProperty = wndHandler:GetData()[2]
		nLayoutLoc = wndHandler:GetData()[3]
	end
	
	
		
	local tMicrochip
	local tSocketIdxData = altself.tSchematicInfo.tSockets[ altself.tLayoutLocToIdx[nLayoutLoc] ]
	if tSocketIdxData and tSocketIdxData.bIsChangeable and not tSocketIdxData.itemDefaultChip then -- Not valid mod conditions
		local nBestGuess = 2
		--if craftingQue == true and wndHandler:GetData()[5] == nil then nBestGuess = 2 end
		local nCurrentPowerCore = altself.tSocketItems[1] and altself.tSocketItems[1]:GetItemId()
		local tMicrochips = CraftingLib.GetAvailableMicrochips(altself.tSchematicInfo.nSchematicId, eProperty, nBestGuess, 0, nCurrentPowerCore)

		if tMicrochips and tMicrochips[1] then
			if tSavedValues  and tSavedValues[4] then 
				altself.tSocketItems[nLayoutLoc] = tSavedValues[4]
				tMicrochip = tSavedValues[4]
			else
				altself.tSocketItems[nLayoutLoc] = tMicrochips[1]
				tMicrochip = tMicrochips[1] 	
			end	
			if SoketRecording == true then
				wndSocket:FindChild("CircuitPickerSmallLeft"):Enable(false)
				wndSocket:FindChild("CircuitPickerSmallRight"):Enable(true)

				wndSocket:FindChild("CircuitPickerSmallLeft"):SetData({ nBestGuess = nBestGuess - pickerStep, wndSocket = wndSocket, eProperty = eProperty, nLayoutLoc = nLayoutLoc })
				wndSocket:FindChild("CircuitPickerSmallRight"):SetData({ nBestGuess = nBestGuess + pickerStep, wndSocket = wndSocket, eProperty = eProperty, nLayoutLoc = nLayoutLoc })
			end
			for k, v in pairs(viragsAutoCircuit.RandomProperty) do

				--refactor later        			
				--if tMicrochips[1]:GetName() == v.n then
				if eProperty == v.p then
					if isRandomChecked == true then 
						for eChipType, arProperties in pairs(CraftingLib.GetAvailableProperties(self.tSchematicInfo.nSchematicId, nCurrentPowerCore )) do
							for idx, ieProperty in pairs(arProperties) do
								if ieProperty ~= eProperty then 
									if table.getn(Property) == 1 then
										
										--local inBestGuess = altself:HelperBestGuessMicrochip(ieProperty)
										local itMicrochips = CraftingLib.GetAvailableMicrochips(altself.tSchematicInfo.nSchematicId, ieProperty, 2, 0, nCurrentPowerCore )
										altself.tSocketItems[nLayoutLoc] = itMicrochips[1]
										tMicrochip = itMicrochips[1] 
									else
										
										for k, vl in pairs(Property) do
											if vl.tSavedValues[2] ~= eProperty and vl.tSavedValues[2] ~= ieProperty then
												--local inBestGuess = altself:HelperBestGuessMicrochip(ieProperty)
												local itMicrochips = CraftingLib.GetAvailableMicrochips(altself.tSchematicInfo.nSchematicId, ieProperty, 2, 0, nCurrentPowerCore)
												altself.tSocketItems[nLayoutLoc] = itMicrochips[1]
												tMicrochip = itMicrochips[1] 
												
												break
											end
										end
									end
								break
								end
							end	
						end
					else 
						if bRepeatLastCraft == false then
							viragsAutoCircuit:PRINT("Random attribute is the same as the chosen one. Recorded item cleared.")
						end
						viragsAutoCircuit.IsRandomFailed = true								 
					end	
				end			
			end
		end
	end
	
	if SoketRecording == true then
		for k, v in pairs(Property) do
			if nLayoutLoc == v.nLayoutLoc  then
				Property[k] = {h = wndHandler, c = wndControl, m = tMicrochip, 
				eProperty = eProperty, nLayoutLoc = nLayoutLoc , tSavedValues = {wndSocket, eProperty, nLayoutLoc }}
				altself:OnDestroyPropertyPicker()
				return
			end
		end
        Property[PropertyIndex + 1] = {h = wndHandler, c = wndControl, 
			m = tMicrochip, eProperty = wndHandler:GetData()[2], nLayoutLoc = wndHandler:GetData()[3],
			  tSavedValues = {wndSocket, eProperty, nLayoutLoc } }
        PropertyIndex = PropertyIndex + 1
		Apollo.GetAddon("ViragsAutoCircuit"):SetSoketDisplay(PropertyIndex)
    end

	altself:OnDestroyPropertyPicker()
end

function ViragsAutoCircuit:OnCircuitPickerLeftRight(wndHandler, wndControl, craftingQue, tSavedValues) -- CircuitPickerSmallLeft or CircuitPickerSmallRight
	local altself = self
	local viragsAutoCircuit = Apollo.GetAddon("ViragsAutoCircuit")
	local isRandomChecked = viragsAutoCircuit.wndMain:FindChild("PropertyCheckBox"):IsChecked()
	local pickerStep = tonumber(viragsAutoCircuit.wndMain:FindChild("PickerStep"):GetText())
	if craftingQue == true then isRandomChecked = true end
	--local altself = Apollo.GetAddon("Crafting").luaSchematic
	local wndSocket 
	local nBestGuess
	local eProperty
	local nLayoutLoc
	local rightOrLeft
	local oldPicker
	if wndHandler == nul or wndHandler:GetData() == nul then
		wndSocket = tSavedValues[1] 
		eProperty = tSavedValues[2]
		nLayoutLoc = tSavedValues[3]
		nBestGuess = tSavedValues[4] and tSavedValues[4] or 2
	else 
		wndSocket = wndHandler:GetData().wndSocket
		nBestGuess = wndHandler:GetData().nBestGuess
		eProperty = wndHandler:GetData().eProperty
		nLayoutLoc = wndHandler:GetData().nLayoutLoc
		rightOrLeft = wndHandler:GetData()[5]
		oldPicker = wndHandler:GetData()[6]
	end
	--[[
	if rightOrLeft ~= nil then
		if rightOrLeft == true then
			if oldPicker then
				nBestGuess = nBestGuess - oldPicker + pickerStep
			end
			-- -5 + 3
		else 
			nBestGuess = nBestGuess + oldPicker - pickerStep
		end
	
		if SoketRecording == false then
			--pickerStep = wndHandler:GetData()[5]
			if rightOrLeft == true then
				nBestGuess = nBestGuess - pickerStep 
			else 
				nBestGuess = nBestGuess + pickerStep 
			end
		end
	end
	]]
	
	
	local nCurrentPowerCore = self.tSocketItems[1] and self.tSocketItems[1]:GetItemId()	
	-- nShiftRange is how far ahead to seek in GetAvailableMicrochips
	local nNewLeft = 0
	local nNewRight = 0
	local nShiftRange = 5

	local tMicrochips = CraftingLib.GetAvailableMicrochips(self.tSchematicInfo.nSchematicId, eProperty, nBestGuess, nShiftRange, nCurrentPowerCore)
	if tMicrochips and tMicrochips[nShiftRange] and Apollo.IsShiftKeyDown() and wndHandler:GetName() == "CircuitPickerSmallRight" then
		nNewLeft = nBestGuess + nShiftRange - 2
		nNewRight = nBestGuess + nShiftRange
		self.tSocketItems[nLayoutLoc] = tMicrochips[nShiftRange]
	elseif tMicrochips and tMicrochips[1] then
		nNewLeft = nBestGuess - 1
		nNewRight = nBestGuess + 1
		self.tSocketItems[nLayoutLoc] = tMicrochips[1]
	end

	-- Enable / Disable if valid
	



	if tMicrochips and tMicrochips[1] then
		altself.tSocketItems[nLayoutLoc] = tMicrochips[1]
		--needs recoding
		for k, v in pairs(viragsAutoCircuit.RandomProperty) do
       			if eProperty == v.p and isRandomChecked then 
					for eChipType, arProperties in pairs(CraftingLib.GetAvailableProperties(self.tSchematicInfo.nSchematicId, nCurrentPowerCore )) do
						for idx, ieProperty in pairs(arProperties) do
							if ieProperty ~= eProperty then 
								if table.getn(Property) == 1 then
									local inBestGuess = 2
									local itMicrochips = CraftingLib.GetAvailableMicrochips(altself.tSchematicInfo.nSchematicId, ieProperty, inBestGuess, 1, nCurrentPowerCore)
									altself.tSocketItems[nLayoutLoc] = itMicrochips[1]
								else
									for k, vl in pairs(Property) do
										if vl.tSavedValues[2] ~= eProperty and vl.tSavedValues[2] ~= ieProperty then
											local inBestGuess = 2
											local itMicrochips = CraftingLib.GetAvailableMicrochips(altself.tSchematicInfo.nSchematicId, ieProperty, inBestGuess, 1, nCurrentPowerCore)
											altself.tSocketItems[nLayoutLoc] = itMicrochips[1]
											break
										end
									end
								end
							break
								
							end
						end						
					end
				end
			end

		
		
		if SoketRecording == true then
		local tValidLeft = CraftingLib.GetAvailableMicrochips(self.tSchematicInfo.nSchematicId, eProperty, nNewLeft, 1, nCurrentPowerCore)
		local tValidRight = CraftingLib.GetAvailableMicrochips(self.tSchematicInfo.nSchematicId, eProperty, nNewRight, 1, nCurrentPowerCore)
		wndSocket:FindChild("CircuitPickerSmallLeft"):Enable(tValidLeft and tValidLeft[1])
		wndSocket:FindChild("CircuitPickerSmallRight"):Enable(tValidRight and tValidRight[1])
		wndSocket:FindChild("CircuitPickerSmallLeft"):SetData({ nBestGuess = nNewLeft, wndSocket = wndSocket, eProperty = eProperty, nLayoutLoc = nLayoutLoc, false, pickerStep })
		wndSocket:FindChild("CircuitPickerSmallRight"):SetData({ nBestGuess = nNewRight, wndSocket = wndSocket, eProperty = eProperty, nLayoutLoc = nLayoutLoc, true, pickerStep })
		end
	end

	
	
	if SoketRecording == true then
		for k, v in pairs(Property) do
			if nLayoutLoc == v.tSavedValues[3] then
				Property[k] = { h = v.h, c = v.c, m = altself.tSocketItems[nLayoutLoc], pH = wndHandler, pC = wndControl,
				eProperty = eProperty , nLayoutLoc = nLayoutLoc, tSavedValues = v.tSavedValues, bLeftRight = true }
				Property[k].tSavedValues[4] = nBestGuess 
			end
		end

		--v = Property[PropertyIndex]
		--Property[PropertyIndex]
        --Picker[PickerIndex ] = {h = wndHandler, c = wndControl, }
        --PickerIndex = PickerIndex + 1 
    end
	altself:OnDestroyPropertyPicker()
end

function ViragsAutoCircuit:OnPowerCoreItemBtn(wndHandler, wndControl, craftingQue, nMode, tPowerCore) -- PowerCoreItemBtn, data is tCurrentPowerCore
	local altself = Apollo.GetAddon("Crafting").luaSchematic
	local viragsAC = Apollo.GetAddon("ViragsAutoCircuit")

	altself.wndMain:FindChild("SocketsLayer"):FindChild("PowerCorePickerBtn"):SetCheck(false)
	altself.tSocketItems = {}
	if wndHandler == nul or wndHandler:GetData() == nul then
		altself.tSocketItems[1] = tPowerCore
	else
		altself.tSocketItems[1] = wndHandler:GetData()
	end
	if altself.tSocketItems[1]:GetBackpackCount() == 0 then
		local isPowerChecked = viragsAC.wndMain:FindChild("PowerCheckBox"):IsChecked()
		local isDesiredCoreChecked = viragsAC.wndMain:FindChild("DesiredPowerCheckBox"):IsChecked()
		if craftingQue == true and nMode == 1 then isPowerChecked = true end
		if isDesiredCoreChecked and nMode == 1 then isPowerChecked = false end
		
		if not isPowerChecked then
			viragsAC:OnViragsAutoCircuitStop()
			viragsAC:PRINT("Not enough " .. altself.tSocketItems[1]:GetName() .. ", crafting stopped.")
		else
			local currentCraft = CraftingLib.GetCurrentCraft()
			local tAvailableCores = CraftingLib.GetAvailablePowerCores(currentCraft.nSchematicId)		
			if tAvailableCores then -- Some crafts won't have power cores
				local oldCores = altself.tSocketItems[1]:GetName()
				for idx, tMaterial in pairs(tAvailableCores) do
					if tMaterial:GetBackpackCount() > 0 then 
						altself.tSocketItems[1] = tMaterial 

						-- wndHandler:SetData(tMaterial)
					end
				end
				viragsAC:PRINT("Not enough " .. oldCores .. ", using " .. wndHandler:GetData():GetName() .. ".")
			end
		end
	end
	
	if SoketRecording == true then
        viragsAC.Power[viragsAC.PowerIndex + 1] = {h = wndHandler, c = wndControl, 
		tPowerCore = altself.tSocketItems[1]}
        viragsAC.PowerIndex = viragsAC.PowerIndex + 1
		viragsAC:ChangeCircuitBoardOverlayMode()
    end
	altself:UpdatePreview()
end


function ViragsAutoCircuit:SetSoketDisplay(count)
	self.wndMain:FindChild("SoketsNumber"):SetText(tostring(count))
end



function ViragsAutoCircuit:StartCrafting(idNSchematic)
	SoketRecording = false
	self.IsRandomFailed = false
	self.Stop = false
	self.wndItems:ClearFocus()


	local carbineCraft = Apollo.GetAddon("Crafting")
	local altself = Apollo.GetAddon("Crafting").luaSchematic
	
	if altself == nil then
		self:PRINT("Default interface addon isn't ready. Open Circuit Board")
		return
	end
	
	local carbineCraftPreviewBtn = carbineCraft.wndMain:FindChild("PreviewStartCraftBtn")
	if carbineCraftPreviewBtn == nil then 
		self:PRINT("Start craft button isn't found, open crafting window.")
		return
	end
	
	if PropertyIndex == 0 then 
		self:PRINT("Fill sockets to start crafting.")
		self:OnClearSokets()
		--Vvv
		return
	end

	if self.PowerIndex == 0 then
   		self:PRINT("Fill the power core socket to start crafting.")
		SoketRecording = true
		return
	end

	if self.Count == 0 then
   		self:PRINT("Items number is 0.")
		SoketRecording = true
		return
	end
	
		
	if GameLib.GetEmptyInventorySlots() == 0 then
		self:PRINT("Inventory is full, crafting stopped.")
		return
	end
	
	carbineCraft:OnPreviewStartCraft(carbineCraftPreviewBtn, carbineCraftPreviewBtn, idNSchematic)
	
	if carbineCraft.wndMain:FindChild("NoMaterialsBlocker"):IsShown() then
		self:PRINT("Not enough materials.")
		return
	end
	--altself:OnCraftingUpdateCurrent()
	--altself:UpdatePreview()
	--self:SetMicrochips(self.SavedConfig[self.listItemIndex].tMicrochips)
	if not self.Stop then self:CompleteCrafting() end	
end

function ViragsAutoCircuit:AddSokets() 
	local altself = Apollo.GetAddon("Crafting").luaSchematic
	
	local bCraftingQue = IsCraftingQue or IsCraftingQueItem
	
		
	for k, v in pairs(self.Power) do
        altself:OnPowerCoreItemBtn(v.h, v.c, bCraftingQue, nMode, v.tPowerCore)
    end

    for k, v in pairs(Property) do
		if v.bLeftRight == true then
			altself:OnCircuitPickerLeftRight(v.pH, v.pC, bCraftingQue, v.tSavedValues)	
		else
        	altself:OnPropertyBtn(v.h, v.c, bCraftingQue, v.tSavedValues)
		end
				
	end
	
	--for k, v in pairs(Picker) do
	--	altself:OnCircuitPickerLeftRight(v.h, v.c)
    --end

	--local tMicrochips, tThresholds = altself:HelperGetUserSelection()
	--local tCraftInfo = CraftingLib.GetPreviewInfo(altself.tSchematicInfo.nSchematicId, tMicrochips, tThresholds)
	--[[for k, v in pairs(tCraftInfo) do
		if v == tCraftInfo.fSchematicBonus then
			self:PRINT("tCraftInfo.fSchematicBonus." .. tCraftInfo.fSchematicBonus)
		end
		
		if v == tCraftInfo.tSockets then
			for k, v in pairs(tCraftInfo.tSockets) do
				for k, v2 in pairs(v) do
					self:PRINT(k)
				end
			end
		end
		
		if v == tCraftInfo.itemPreview then
		end
    end]]

	if self.IsRandomFailed and not self.wndMain:FindChild("PropertyCheckBox"):IsChecked() and bRepeatLastCraft == false then	
		self:OnViragsAutoCircuitStop()
		self:OnClearSokets()
	end
end



function ViragsAutoCircuit:CompleteCrafting()
	local carbineCraft = Apollo.GetAddon("Crafting")
	local carbineCraftButton = carbineCraft.wndMain:FindChild("CraftButton")
	local altself = Apollo.GetAddon("Crafting").luaSchematic

	if carbineCraftButton == nil then
		self:PRINT("Start craft button isn't found, open crafting window.")
		return
	end
	if altself == nil then
		self:PRINT("Default interface addon isn't ready.")
		return
	end

	
	self:AddSokets()
	local tMicrochips, tThresholds = altself:HelperGetUserSelection()
	local tCraftInfo = CraftingLib.GetPreviewInfo(altself.tSchematicInfo.nSchematicId, tMicrochips, tThresholds)
	local arSpells = tCraftInfo.itemPreview:GetDetailedInfo().tPrimary.arSpells
	local desiredIndex = 0
	for k, v in pairs(tDesiredSpecials) do
		desiredIndex = desiredIndex + 1	
	end
	
	if self.SpecialPropertyIndex == 1 and desiredIndex > 0 then
		if arSpells == nil then
			self.timer = ApolloTimer.Create(0.1, false, "CompleteCrafting", self)
			self.timer:Start()
			return
		end
		local bDesiredMatch = false
	
		for id, v in pairs(tDesiredSpecials) do			
			if arSpells[1].strName == v:GetDetailedInfo().tPrimary.tChipInfo.arSpells[1].strName then
				bDesiredMatch = true
			end		
		end		
		
		if bDesiredMatch == false then 
			local bShouldAbandon = self.wndMain:FindChild("AbandonCraftCheckBox"):IsChecked()
			if bShouldAbandon == true then 
				CraftingLib.BotchCraft()
				local abandonTimer = ApolloTimer.Create(0.5, false, "OnCraftingComplete", self)
				--self.timer:Start()]]
				self.wndMain:ToFront()
				self.RandomProperty = {}
				self.SpecialPropertyIndex = 0
				self.RandomPropertyIndex = 0
				return
			end
			local currentCraft = CraftingLib.GetCurrentCraft()
			local tAvailableCores = CraftingLib.GetAvailablePowerCores(currentCraft.nSchematicId)		
			if tAvailableCores then 
				local tFoundMaterial = nil
				for idx, tMaterial in pairs(tAvailableCores) do
					if karPowerCoreTierToString[altself.tSchematicInfo.eTier] ~= "Hybrid" then
						if tMaterial:GetBackpackCount() > 0 and tMaterial:GetItemQuality() <= 3 then 
							tFoundMaterial = tMaterial
						end
					else					
						for id1, strCore in pairs(tDesiredPowerCoreTypes) do
							if id1 < 3	then
								local strP = strCore .. karPowerCoreTierToString[altself.tSchematicInfo.eTier] .. " Power Core"
								if strP == tMaterial:GetName() then 
									tFoundMaterial = tMaterial
								end
							end
						end
					end
				end
				if tFoundMaterial == nil then
					self:PRINT("Not enough green power cores for \"Desired Specials\" option, crafting stopped.")
					--self:OnCancel()
					return
				else 
					altself.tSocketItems[1] = tFoundMaterial

					for k, v in pairs (altself.tSocketItems) do
						if k ~= 1 then
							local tMicrochips = CraftingLib.GetAvailableMicrochips(
							altself.tSchematicInfo.nSchematicId,
							v:GetDetailedInfo().tPrimary.tChipInfo.eProperty, 3)
							altself.tSocketItems[k] = tMicrochips[1]
						end
					end
				end
			end
		else 
			self:PRINT("Desired special match the random one, using chosen power core")
		end
	
	end
		
	for k, v in pairs(self.RandomProperty) do
		if v.n == "Random" then
			--altself:UpdatePreview()
			self.timer = ApolloTimer.Create(0.1, false, "CompleteCrafting", self)
			self.timer:Start()
			
			return 		
		end
	end
	
    self.timer = ApolloTimer.Create(3.5, false, "OnCraftingComplete", self)
	self.timer:Start()
	
	--local item = self.selectedListItem	
	--CraftingLib.CompleteCraft(item.tMicrochips, item.tThresholds)
    carbineCraft:OnCraftBtnClicked(carbineCraftButton, carbineCraftButton)
	self.RandomProperty = {}
	self.SpecialPropertyIndex = 0
	self.RandomPropertyIndex = 0
end

function ViragsAutoCircuit:OnCraftingComplete()
	if tTempQueue == nil then 
		tTempQueue = {}
		self:ChangeRepeatLastMode()
	end
	
	tTempQueue.Power = self.Power
	tTempQueue.Property = Property
	tTempQueue.PropertyIndex = PropertyIndex
	self:SuccessCheck()
	if IsCraftingQueItem == true or IsCraftingQue == true then
		self:RefreshPattern(nCurrentItemIndex)
	end
	
	if self.Stop then
		if self.Count == 0 then
			if nMode == MODE_DAILIES then
				table.remove(self.SavedConfig, nCurrentItemIndex)
			end
			self:AddPattern()
			
			if IsCraftingQue == true then 
				Print("Que next item.")
				self:OnCraftQue()
				return
			end
			
			if IsCraftingQueItem == true then 
				IsCraftingQueItem = false
			end
			
			self.listItemParent = nil
			self.selectedListItem = nil
			self.listItemIndex = nil
	
			Print("Crafting complete.")		
		end
		return
	end
	
	if self.Count >= 1 then
		self.wndItems:SetText(self.Count)
		if IsCraftingQue == true then
			self:OnCraftQue()
			return
		end
		if IsCraftingQueItem == true then
			self:OnCraftQueItem()
			return
		end
		self:StartCrafting()
		return
	elseif self.Count == 0 then
		self.wndItems:SetText(self.Count)
		self:OnClearSokets()
		if IsCraftingQue == true then 
			self:PRINT("Queue next item.")		
			if nMode == MODE_DAILIES then 
				table.remove(self.SavedConfig, 1) 
				self:AddPattern()
			end
			self:OnCraftQue()
			return
		end
		if IsCraftingQueItem == true then 
			if nMode == MODE_DAILIES then 
				table.remove(self.SavedConfig, self.listItemIndex) 
				self:AddPattern()
			end
			IsCraftingQueItem = false
		end

		if bRepeatLastCraft == false then
			self:PRINT("Crafting complete, recorded item cleared.")
		else
			bRepeatLastCraft = false
		end
		
	end
		
end

function ViragsAutoCircuit:SuccessCheck()
	local successCheck = self.wndMain:FindChild("RuneSlotsCheckbox"):IsChecked()
	if successCheck == false or (nMode == MODE_DAILIES and (IsCraftingQueItem == true or IsCraftingQue == true))  then 
		self.Count = self.Count - 1 
	elseif successCheck == true and bTargetItemLooted == true then
		bTargetItemLooted = false
		self.Count = self.Count - 1 
	end
end

function ViragsAutoCircuit:RefreshPattern(nConfig)
	local config = tCurPatterns[nConfig]
	if config ~= nil then
		config.wndListItem:FindChild("ItemsToCraftBox"):SetText(self.Count)
		config.itemsToCraft = self.Count
		self:AddPattern()
	end
end

function ViragsAutoCircuit:OnCircuitOpen()
	Apollo.GetAddon("Crafting").OnCloseBtn = self.OnCraftingCloseBtn
	
    self:OnViragsAutoCircuitOn()
	self:AttachCircuitBoardOverlay()	
	self.wndMain:Show(true)
	self.wndMain:ToFront()
	GameLib:Disembark()
	self:AddPattern()
	--self.timer = ApolloTimer.Create(0.5, false, "CheckSpecials", self)
	self:CheckSpecials()
end

function ViragsAutoCircuit:CheckSpecials(tSchem)
	local altself = Apollo.GetAddon("Crafting").luaSchematic
	local tSchematicInfo = nil
	if tSchem == nil then
		tSchematicInfo = altself.tSchematicInfo
	else
		tSchematicInfo = tSchem
	end
	self.tSchematicSpecials = {}
	self.SpecialPropertyIndex = 0
	--[[for k,v in pairs (altself.tLayoutIdxToLoc) do
		local nSocket = altself.tLayoutLocToIdx[v]
		if altself.tSchematicInfo.tSockets[nSocket].itemDefaultChip then
			if ( altself.tSchematicInfo.tSockets[nSocket].itemDefaultChip:GetName() ~= "Random") then
				local arSpecials = altself.tSchematicInfo.tSockets[nSocket].itemDefaultChip:GetDetailedInfo().tPrimary.tChipInfo.arRandomCircuits
				if arSpecials ~= nil then
					for id, val in pairs(arSpecials) do 
						self.tSchematicSpecials[id] = val.item
					end
					self.SpecialPropertyIndex = 1
				end
				
				--local special = altself.luaSchematic.tSchematicInfo.tSockets[nSocket].itemDefaultChip--:GetDetailedInfo().tPrimary.tChipInfo.arRandomCircuits[1]
				--for idx, val in pairs(special.item:GetDetailedInfo()) do
				--end
				--special:GetDetailedInfo().tPrimary.tChipInfo.arSpells[1].strFlavor
				

			end
		end
	end]]
	for k,v in pairs (tSchematicInfo.tSockets) do
		if tSchematicInfo.tSockets[k].itemDefaultChip then
			if ( tSchematicInfo.tSockets[k].itemDefaultChip:GetName() ~= "Random") then
				local arSpecials = tSchematicInfo.tSockets[k].itemDefaultChip:GetDetailedInfo().tPrimary.tChipInfo.arRandomCircuits
				if arSpecials ~= nil then
					for id, val in pairs(arSpecials) do 
						self.tSchematicSpecials[id] = val.item
					end
					self.SpecialPropertyIndex = 1
				end
			end
		end
	end
end


function ViragsAutoCircuit:OnViragsAutoCircuitStop()
	self.Stop = true
	IsCraftingQue = false
	IsCraftingQueItem = false
	if self.timer == nil then
		return
	end
    self.timer:Stop()
end

function ViragsAutoCircuit:SetSoketDisplay(count)
	self.wndMain:FindChild("SoketsNumber"):SetText(tostring(count))
end


-----------------------------------------------------------------------------------------------
-- ViragsAutoCircuitForm Functions
-----------------------------------------------------------------------------------------------
function ViragsAutoCircuit:OnOK()
	self.Count = tonumber(self.wndItems:GetText())
	self:StartCrafting()
end


function ViragsAutoCircuit:OnCancel()	
	if IsCraftingQue == true or IsCraftingQueItem == true then
		self.RandomProperty = {}
		IsCraftingQue = false
		IsCraftingQueItem = false
		self:AddPattern()
	end
	self:OnViragsAutoCircuitStop()
end

function ViragsAutoCircuit:OnClose()	
	self:OnViragsAutoCircuitStop()
	self.wndMain:Close()
end

function ViragsAutoCircuit:OnCountChanged(wndHandler, wndControl, strText )
	local item = wndHandler:GetName()
	local wndEdit = nil
	local count = nil
	
	if item == "ItemsNumber" then 
		wndEdit = self.wndItems
		count = self:ValidateInput(strText, 9001)
	else 
		wndEdit = self.wndAttrStep 
		count = self:ValidateInput(strText, 100)
	end
	
	if count then wndHandler:SetText(count) end
end

function ViragsAutoCircuit:OnQueItemsCountChanged( wndHandler, wndControl, strText )
	local count = self:ValidateInput(strText, 9001)
	local key = wndHandler:GetData()
	if tCurPatterns[key].itemsToCraft then
		if count then 
			wndHandler:SetText(self:ValidateInput(strText, 9001))
			tCurPatterns[key].itemsToCraft = count
		else 
			tCurPatterns[key].itemsToCraft = tonumber(strText)
		end
		self:RefreshMaterialsWnd(wndHandler:GetParent():GetParent(),
		CraftingLib.GetSchematicInfo(tCurPatterns[key].nSchematicId),
		tCurPatterns[key].itemsToCraft)
	end	
end

function  ViragsAutoCircuit:ValidateInput(strText, num) 
	local count =  tonumber(strText)	
	if count == nil or count <= 0 then 
		count = 0 
		return count
	elseif count > num then
		count = num
		return count
	end
	return nil
end

function ViragsAutoCircuit:OnPickerUp(wndHandler, wndControl)
	local parent = wndHandler:GetParent():GetName()
	if parent == "PickerItems" then
		local wndNumber = wndHandler:GetParent():FindChild("ItemsNumber")
		wndNumber:SetText(tonumber(wndNumber:GetText()) + 1)
		--self.wndItems:SetText(tonumber(self.wndItems:GetText()) + 1)
	else
		self.wndAttrStep:SetText(tonumber(self.wndAttrStep:GetText()) + 1)
	end
end

function ViragsAutoCircuit:OnPickerDown(wndHandler, wndControl)	
	local parent = wndHandler:GetParent():GetName()
	local wndPicker = nil
	if parent == "PickerItems" then 
		wndPicker = wndHandler:GetParent():FindChild("ItemsNumber")
	else 
		wndPicker = self.wndAttrStep 
	end

	if (tonumber(wndPicker:GetText()) > 1 ) then
			wndPicker:SetText(tonumber(wndPicker:GetText()) - 1)
	end
end


function ViragsAutoCircuit:OnClearSokets()
	SoketIndex = 0
	self.PowerIndex = 0
	PropertyIndex = 0
	PickerIndex = 0
	self.RandomPropertyIndex = 0
	self.RandomProperty = {}
	Sokets = {}
	self.Power = {}
	Property = {}
	Picker = {}
	SoketRecording = true
	
	
	wndSokets = {}
	wndSocketsIndex = 0
	self:SetSoketDisplay(SoketIndex)
end

function ViragsAutoCircuit:OnChangeMode( wndHandler, wndControl, eMouseButton )
	if nMode == MODE_DAILIES then
		nMode = MODE_SCHEMATICS
	else
		nMode = MODE_DAILIES
	end
	
	self:SwitchCurrentPatterns(nMode)
	self:ChangeQueueState()
	self:AddPattern()
end

function ViragsAutoCircuit:ChangeQueueState()
	self.wndMain:FindChild(wndNames[wndSize].patternList):FindChild("DailiesHelperText"):SetText(wndTitles[nMode][wndSize])
	if wndSize == PATTERN_LIST_BIG then
		local strMicro = ""
		if nMode == MODE_DAILIES then
			strMicro = "Materials"
		else
			strMicro = "Microchips"
		end
		
		self.wndMain:FindChild(wndNames[wndSize].patternList):FindChild("Headers"):FindChild("Microchips"):SetText(strMicro)
	end	
end

function ViragsAutoCircuit:OnStayOnTopCheck( wndHandler, wndControl, eMouseButton )
	bStayOnTop = true 
	Apollo.GetAddon("Crafting").wndMain:SetStyle("NeverBringToFront",true)
end

function ViragsAutoCircuit:OnStayOnTopUncheck( wndHandler, wndControl, eMouseButton )
	bStayOnTop = false 
	Apollo.GetAddon("Crafting").wndMain:SetStyle("NeverBringToFront",false)	
end

-----------------------------------------------------------------------------------------------
-- Save Patterns Begin
-----------------------------------------------------------------------------------------------





function ViragsAutoCircuit:OnCraftQueItem()
	
	if not self.listItemParent then
		self:PRINT("Please Select the Queue Item.")
		return
	end
	--PreviewStartCraftBtn
	local item = self.selectedListItem
	if CraftingLib.GetCurrentCraft() ~= nil then
		self:PRINT ("Finish current craft to start crafting.")
		return
		--CraftingLib.CraftItem(item.nSchematicId)
	end

	config = tCurPatterns[self.listItemIndex]
	self.Count = tonumber(config.wndListItem:FindChild("ItemsToCraftBox"):GetText())

	IsCraftingQueItem = true
	self.Power = {} 
	local carbineCraft = Apollo.GetAddon("Crafting")	
	local carbineCraftPreviewBtn = carbineCraft.wndMain:FindChild("PreviewStartCraftBtn")
	local idSchematic = config.nSchematicId--carbineCraft.wndMain:GetData()
	local tSchematicInfo = CraftingLib.GetSchematicInfo(idSchematic)
	nCurrentItemIndex = self.listItemIndex
	self:GetAvailable(config, tSchematicInfo)	
	if not bHasEnoughMaterials then
		self:PRINT("Not enough materials.")
		return
	end
	if tSchematicInfo.bIsAutoCraft then
		self.timer = ApolloTimer.Create(3.5, false, "OnCraftingComplete", self)
		local nCraftAtOnceMax = tSchematicInfo.nCreateCount 
		local nToCraft = math.min(self.Count, nCraftAtOnceMax, self:GetAvailable(config, tSchematicInfo))
		self.Count = self.Count - nToCraft + 1
		if bHasEnoughMaterials == true then
			CraftingLib.CraftItem(tSchematicInfo.nSchematicId, nil, nToCraft)
		end 
		return
	else
		carbineCraftPreviewBtn:SetData(item.nSchematicId)
		carbineCraft:OnPreviewStartCraft(carbineCraftPreviewBtn, carbineCraftPreviewBtn)
	end
	self:CheckSpecials()
	
	SoketIndex = config.SoketIndex 
	PickerIndex = config.PickerIndex 
	PropertyIndex = config.PropertyIndex 
	Sokets = {} 
	Property = {} 
	Picker = {} 
	if nMode == MODE_DAILIES then 
		self:SetMicrochips(config.tMicrochips, config.nProperty )
	else
		self:LoadMicrochips(config.tMicrochips)
	end
end


function ViragsAutoCircuit:LoadMicrochips(tMicrochips)
	local altself = Apollo.GetAddon("Crafting").luaSchematic
	if self.Power[1] == nil then self.Power[1] = {} end
	local CircuitPickerBtn = altself.wndMain:FindChild("CircuitPickerBtn")
	local CircuitPickerSmallLeft = altself.wndMain:FindChild("CircuitPickerSmallLeft")
	local PowerCoreItemBtn = altself.wndMain:FindChild("PowerCoreItemBtn")
	local tSchematicInfoSockets = altself.tSchematicInfo.tSockets
	
	local nPrIndex = 1
	for idx = 1, #altself.tSchematicInfo.tSockets do
		local nLayoutLoc = altself.tLayoutIdxToLoc[idx] -- TODO REFACTOR: These arrays are parallel and can be rewritten
		if nLayoutLoc == 1 then
			local nPowerCoreId = tMicrochips[1]
			local powerCore = Item.GetDataFromId(nPowerCoreId )
			if powerCore~= nil then
				--self.Power[1].h = PowerCoreItemBtn
				--self.Power[1].c = PowerCoreItemBtn
				self.Power[1].tPowerCore = powerCore 
				self.PowerIndex = 1
				--self.Power[1].h:SetData(powerCore)
			end
		elseif nLayoutLoc then		
			if tMicrochips[idx]~= nil and tMicrochips[idx]~= 0 then
				local item = Item.GetDataFromId(tMicrochips[idx])
				local tItemInfo = item:GetMicrochipInfo()
				Property[nPrIndex] = {}
				local wndSocket = altself.tSocketButtons[nLayoutLoc]
				--Property[nPrIndex].h = wndSocket
				--Property[nPrIndex].c = wndSocket
				--Property[nPrIndex].h:SetData(  { wndSocket , tItemInfo.idUnitProperty, nLayoutLoc, item, true } 	)
				Property[nPrIndex].tSavedValues = { wndSocket , tItemInfo.idUnitProperty, nLayoutLoc, item, true }
				nPrIndex = nPrIndex + 1
			end
			--if altself.tSocketItems[nLayoutLoc] then
				--altself.tSocketItems[nLayoutLoc] = Item.GetDataFromId(tMicrochips[idx])
				 --= altself.tSocketItems[nLayoutLoc]:GetItemId()
			--end

			--[[tThresholds[idx] = 0
			if self.tSocketThresholds[nLayoutLoc] and self.nTEMPThresholdSelected[nLayoutLoc] then
				tThresholds[idx] = self.nTEMPThresholdSelected[nLayoutLoc] - 1 -- GOTCHA: C++ is index by 0 instead of 1
			end]]
		end
	end
	self:StartCrafting()
end

function ViragsAutoCircuit:OnCraftQue()
	if table.getn(tCurPatterns) == 0 then
		self:PRINT("No patterns to craft, crafting stopped.")
		IsCraftingQue = false
		--CraftQueIndex = 0
		return
	end
	if CraftingLib.GetCurrentCraft() ~= nil then
		self:PRINT ("Finish current craft to start crafting.")
		return
	end
	IsCraftingQue = true
	--CraftQueIndex = CraftQueIndex + 1

	--v.wndListItem:FindChild("QueListItemButton")
	local nIndex = craftQueIndex
	--if not nIndex then nIndex = 1 end


	--PreviewStartCraftBtn
		
	--if CraftingLib.GetCurrentCraft() == nil then
	--CraftingLib.CraftItem(item.nSchematicId)
	--end
	config = tCurPatterns[nIndex]	
	nCurrentItemIndex = nIndex

	if config ~= nil then
		self.Count = tonumber(config.wndListItem:FindChild("ItemsToCraftBox"):GetText())
		if self.Count == 0 then 
			craftQueIndex = craftQueIndex + 1
			self:OnCraftQue() 		
			return
		end
		local item = config.wndListItem:GetData()
		self.Power = {} 
		local carbineCraft = Apollo.GetAddon("Crafting")	
		local carbineCraftPreviewBtn = carbineCraft.wndMain:FindChild("PreviewStartCraftBtn")
		local idSchematic = config.nSchematicId--carbineCraft.wndMain:GetData()
		local tSchematicInfo = CraftingLib.GetSchematicInfo(idSchematic)
		self:GetAvailable(config, tSchematicInfo)
		
		if not bHasEnoughMaterials then
			self:PRINT("Not enough materials.")
			return
		end
		
		if tSchematicInfo.bIsAutoCraft then
			self.timer = ApolloTimer.Create(3.5, false, "OnCraftingComplete", self)
			local nCraftAtOnceMax = tSchematicInfo.nCreateCount 
			local nToCraft = math.min(self.Count, nCraftAtOnceMax, self:GetAvailable(config, tSchematicInfo))
			self.Count = self.Count - nToCraft + 1
			if bHasEnoughMaterials == true then
				CraftingLib.CraftItem(tSchematicInfo.nSchematicId, nil, nToCraft)
			end 
			return
		end
		carbineCraftPreviewBtn:SetData(item.nSchematicId)
		carbineCraft:OnPreviewStartCraft(carbineCraftPreviewBtn, carbineCraftPreviewBtn)
		self:CheckSpecials()
		SoketIndex = config.SoketIndex 
		PickerIndex = config.PickerIndex 
		PropertyIndex = config.PropertyIndex 
		Sokets = {} 
		Property = {} 
		Picker = {} 
		 
		if nMode == MODE_DAILIES then 
			self:SetMicrochips(config.tMicrochips, PropertyIndex, config.nProperty )
		else
			self:LoadMicrochips(config.tMicrochips)
		end
	else
		craftQueIndex = 1
		self:PRINT("No patterns to craft, crafting stopped.")
	end
end

function ViragsAutoCircuit:SetMicrochips(tMicrochips, nProperty)
	local altself = Apollo.GetAddon("Crafting").luaSchematic
	
	--[[if CraftingLib.GetCurrentCraft() == nil then
		CraftingLib.CraftItem(tItem.nSchematicId)
	end]]
	--local PropertyPickerAGBBtn = altself.wndMain:FindChild("PropertyPickerAGBBtn")
	if self.Power[1] == nil then self.Power[1] = {} end
	local CircuitPickerBtn = altself.wndMain:FindChild("CircuitPickerBtn")
	
	local CircuitPickerSmallLeft = altself.wndMain:FindChild("CircuitPickerSmallLeft")

	local PowerCoreItemBtn = altself.wndMain:FindChild("PowerCoreItemBtn")
	local eProp = {}
	local ePropId = 1
	local tCores = CraftingLib.GetAvailablePowerCores(altself.tSchematicInfo.nSchematicId)
	local nCurrentPowerCore = tCores[1]:GetItemId()--altself.tSocketItems[1] and altself.tSocketItems[1]:GetItemId()
	for eChipType, arProperties in pairs(CraftingLib.GetAvailableProperties(altself.tSchematicInfo.nSchematicId, nCurrentPowerCore)) do
		for idx, eProperty in pairs(arProperties) do
			if eProperty ~= 6 and eProperty ~= 34  then
				eProp[ePropId] = eProperty
				ePropId = ePropId + 1
			end
		end
	end
	--eProp[2] = 0
	--eProp[3] = 4
	

		
	local tSchematicInfoSockets = altself.tSchematicInfo.tSockets
	local nLay = {}
	local inLay = 1
	local tCurrentCraft = CraftingLib.GetCurrentCraft()
	if not tCurrentCraft then
		self:PRINT("Crafting stopped.")
		return
	end
	local tMicrochips = tCurrentCraft.tMicrochips
	for k,v in pairs (altself.tLayoutIdxToLoc) do
		local nSocket = altself.tLayoutLocToIdx[v]
		
		if tMicrochips and tMicrochips[k].itemChip then
		else
			nLay[inLay] = v
			inLay = inLay + 1
		end
	end
	
	
	--[[for iIndex, tMicrochip in pairs(tCurrentCraft.tMicrochips) do
		if tMicrochip.itemChip then
		end
	end]]

	index = table.getn(nLay)
	SoketIndex = index
	PickerIndex = index 
	PropertyIndex = index 

	local item 
	Property = {}
	
	for k,v in pairs(nLay) do
		if k == 1 then
			--item = Item.GetDataFromId(v)
			--self.Power[1].h = PowerCoreItemBtn
			--self.Power[1].c = PowerCoreItemBtn	
			
			--local currentCraft = CraftingLib.GetCurrentCraft()
			local tAvailableCores = CraftingLib.GetAvailablePowerCores(altself.tSchematicInfo.nSchematicId)		
			if tAvailableCores then -- Some crafts won't have power cores
				local tGreen = nil
				local tBlue	= nil
				local tChosenMaterial = nil
				local tDesired = nil
				for idx, tMaterial in pairs(tAvailableCores) do
					local eItemQuality = tMaterial:GetItemQuality() or 1
					if tMaterial:GetBackpackCount() > 0 then 
						
						for id1, strCore in pairs(tDesiredCores) do
							if strCore ~= nil then
								local strP = strCore .. karPowerCoreTierToString[altself.tSchematicInfo.eTier] .. " Power Core"
								if strP == tMaterial:GetName() then  
									tDesired = tMaterial
								end
							end
						end 
						--PowerCoreItemBtn:SetData( tMaterial )
						if eItemQuality <= 3 then
							tGreen = tMaterial
						else 
							local strP = "Refined " .. karPowerCoreTierToString[altself.tSchematicInfo.eTier] .. " Power Core"
							if strP == tMaterial:GetName() then 
								tBlue = tMaterial
							end
						end
						--break
					end
				end
				
				if tGreen ~= nil then
					tChosenMaterial = tGreen
				elseif tBlue ~= nil then
					tChosenMaterial = tBlue
				end
	
				if tDesired ~= nil then
					tChosenMaterial = tDesired
				elseif tDesired == nil and self.wndMain:FindChild("DesiredPowerCheckBox"):IsChecked() then
					tChosenMaterial = nil
				end
				
				if tChosenMaterial ~= nil then
					--self.Power[1].h:SetData(tChosenMaterial)
					self.Power[1].tPowerCore = tChosenMaterial
					self.PowerIndex = 1
				else
					self:PRINT("Not enough Power Cores or Use Only Desired Power Cores option is checked, crafting stopped.")
					return
				end
	
			end
		end

		
		if k > 1 then 
			local newK = k - 1	
			Property[newK] = {}		
				local nBestGuess = 2
				local tMicrochips = CraftingLib.GetAvailableMicrochips(altself.tSchematicInfo.nSchematicId, eProp[newK], 3)
				altself.tSocketItems[nLay[k]] = tMicrochips[1]

				--local wndSocket = altself.tSocketButtons[altself.tLayoutLocToIdx[nProperty[newK].nLayoutLoc]]
				local wndSocket = altself.tSocketButtons[altself.tLayoutLocToIdx[nLay[k]]]
				--Property[newK].h = wndSocket
				--Property[newK].c = wndSocket
				--Property[newK].h:SetData(  { wndSocket , eProp[newK], nLay[k] } 	)
				Property[newK].tSavedValues = { wndSocket , eProp[newK], nLay[k] }


				if (Property[newK].pH) then
					Property[newK].pH = CircuitPickerSmallLeft
					Property[newK].pC = CircuitPickerSmallLeft
					Property[newK].pH:SetData(  { wndSocket , eProp[newK], nLay[k] } 	)
	
				end
		end
		
	end
	
	self:StartCrafting()
	
end

function ViragsAutoCircuit:OnPatternsButtonCheck()
	self:AddPattern()
	self.wndMain:FindChild(wndNames[wndSize].patternList):Show(true)
end

function ViragsAutoCircuit:OnPatternsButtonUncheck()
	self.wndMain:FindChild(wndNames[wndSize].patternList):Show(false)
end



function ViragsAutoCircuit:AttachCircuitBoardOverlay()
	local carbineCraft = Apollo.GetAddon("Crafting")
	local wndParent = carbineCraft.wndMain:FindChild("CraftingForm")	
	local listItem = Apollo.LoadForm(self.xmlDoc, "PatternListItem", nil, self)
	itemHeight = listItem:GetHeight()
	listItem:Destroy()
	
	local wndOverlay = wndParent:FindChild("SchematicsOverlay")
	local wndRepeatOverlay = wndParent:FindChild("RepeatOverlay")
	local wndShowCircuit = wndParent:FindChild("CircuitToggle")
	
	if not wndShowCircuit then
		wndShowCircuit = Apollo.LoadForm(self.xmlDoc, "CircuitToggle",
		 wndParent , self)
		local closeLeft, closeTop, closeRight, closeBottom = wndParent:FindChild("CloseButton"):GetAnchorOffsets()
		local circuitTOffsetLeft = 48
		--if Apollo.GetAddon("ViragsAutoCoordinate") == nil then
		--	circuitTOffsetLeft = 96
		--end
		wndShowCircuit:SetAnchorOffsets(closeLeft - circuitTOffsetLeft, closeTop + 15, closeLeft, closeTop + 63)		
	end
	
	if wndOverlay ~= nil then
		wndOverlay:Destroy()
		wndOverlay = nil
		wndRepeatOverlay:Destroy()
		wndRepeatOverlay = nil
	end
	
	if not wndOverlay then	
		wndOverlay = Apollo.LoadForm(self.xmlDoc, "SchematicsOverlay", wndParent , self)
		local wndMeasure = wndParent:FindChild("CraftButton")
		local overlayHeight = wndMeasure:GetHeight()
		local overlayLeft, overlayTop, overlayRight, overlayBottom = wndMeasure:GetAnchorOffsets()	
		wndOverlay:SetAnchorOffsets(overlayLeft, overlayBottom + 10, overlayRight, overlayBottom + wndOverlay:GetHeight() + 10)
		wndRepeatOverlay = Apollo.LoadForm(self.xmlDoc, "RepeatOverlay", wndParent , self)
		--wndMeasure = wndParent:FindChild("CraftButton")
		overlayHeight = wndOverlay:GetHeight()
		overlayLeft, overlayTop, overlayRight, overlayBottom = wndOverlay:GetAnchorOffsets()	
		wndRepeatOverlay:SetAnchorOffsets(overlayLeft, overlayBottom, overlayRight, overlayBottom + overlayHeight)
		if tTempQueue == nil then 
			self:ChangeRepeatLastMode()
		end
	end
	wndOverlay:ToFront()
	--Apollo.GetAddon("ViragsAutoCircuit"):ChangeCircuitBoardOverlayMode()
	self:ChangeCircuitBoardOverlayMode()
end

function ViragsAutoCircuit:ChangeRepeatLastMode()
	local carbineCraft = Apollo.GetAddon("Crafting")
	local wndParent = carbineCraft.wndMain:FindChild("CraftingForm")
	local wndRepeatOverlay = wndParent:FindChild("RepeatOverlay")
	if wndRepeatOverlay == nil then return end
	if tTempQueue == nil then
		wndRepeatOverlay:FindChild("OverlayButton"):Enable(false)
	else
		wndRepeatOverlay:FindChild("OverlayButton"):Enable(true)
	end
end

function ViragsAutoCircuit:ChangeCircuitBoardOverlayMode()
	local carbineCraft = Apollo.GetAddon("Crafting")
	local wndParent = carbineCraft.wndMain:FindChild("CraftingForm")
	local wndOverlay = wndParent:FindChild("SchematicsOverlay")

	if CraftingLib:GetCurrentCraft() == nil or self.PowerIndex == 0 then
		wndOverlay:FindChild("OverlayButton"):Enable(false)
	else
		wndOverlay:FindChild("OverlayButton"):Enable(true)
	end
end

function ViragsAutoCircuit:AttachtTradeskillsOverlay()
	--[[if not self.wndMain:IsShown() then 
		self.wndMain:Show(true) 
		self.wndMain:ToFront()
	end]]
	--self.bCoordCraft = tTradeskillInfo.bIsCoordinateCrafting
	local carbineTradeskills = Apollo.GetAddon("TradeskillSchematics")
	if not carbineTradeskills then return end
	local wndParent = carbineTradeskills.wndMain:FindChild("RightBottomCraftPreview")--RightBottomCraftBtn")	
	local wndContainer = Apollo.FindWindowByName("TradeskillContainerForm")
	local listItem = Apollo.LoadForm(self.xmlDoc, "PatternListItem", nil, self)
	itemHeight = listItem:GetHeight()
	listItem:Destroy()
	
	local wndOverlay = carbineTradeskills.wndMain:FindChild("ViragsAutoCircuitOverlay")
	local wndShowCircuit = wndContainer:FindChild("CircuitToggle")
	
	--if wndShowCircuit ~= nil then
	--	wndShowCircuit:Destroy()
	--end
	
	if not wndShowCircuit then
		wndShowCircuit = Apollo.LoadForm(self.xmlDoc, "CircuitToggle",
		 wndContainer , self)
		local closeLeft, closeTop, closeRight, closeBottom = wndContainer:FindChild("CloseButton"):GetAnchorOffsets()
		local circuitTOffsetLeft = 48
		--if Apollo.GetAddon("ViragsAutoCoordinate") == nil then
		--	circuitTOffsetLeft = 96
		--end
		wndShowCircuit:SetAnchorOffsets(closeLeft - circuitTOffsetLeft, closeTop - 5, closeLeft, closeTop + 43)		
	end
	
	if wndOverlay ~= nil then
		wndOverlay:Destroy()
		wndOverlay = nil
	end
	
	if not wndOverlay then	
		wndOverlay = Apollo.LoadForm(self.xmlDoc, "ViragsAutoCircuitOverlay",
		  wndParent, self)
		local offsetLeft, offsetTop  = 30, 5
		local overlayLeft, overlayTop, overlayRight, overlayBottom = wndOverlay:GetAnchorOffsets()	
		wndOverlay:SetAnchorOffsets(overlayLeft + offsetLeft, overlayTop + offsetTop, overlayRight + offsetLeft, overlayBottom + offsetTop)
	end
	
	wndOverlay:SetData(wndParent:GetParent())
	wndOverlay:ToFront()

end

function ViragsAutoCircuit:OnObscuredAddonVisible(strName)
	if strName == "TradeskillSchematics" then
		local tTradeskillSchematics = Apollo.GetAddon("TradeskillSchematics")
		if tTradeskillSchematics ~= nil then
			self.timer = ApolloTimer.Create(0.5, false, "AttachtTradeskillsOverlay", self)
			self.timer:Start()
		end
	elseif strName == "TradeskillContainer" then
		--Apollo.GetAddon("TradeskillContainer").OnClose = self.OnCloseTradeskills
	end
end

function ViragsAutoCircuit:OnSavePattern(wndHandler, wndControl)
	self.wndMain:FindChild("PatternsButton"):SetCheck(true)
	self:OnPatternsButtonCheck()
	self.wndMain:Show(true)

	local tSchematicInfo = nil
	local nSchematicId 	= nil
	local wndParent = wndHandler:GetParent()
	if wndParent:GetData() == nil then
		local carbineCraft = Apollo.GetAddon("Crafting")
		local altself = Apollo.GetAddon("Crafting").luaSchematic	
		local tSchematic = CraftingLib.GetCurrentCraft()
		tSchematicInfo = altself.tSchematicInfo
		nSchematicId = altself.tSchematicInfo.nSchematicId
	else 
		nSchematicId = wndParent:GetData():GetData().nSchematicId
		tSchematicInfo = CraftingLib.GetSchematicInfo(nSchematicId)
	end
	--[[if tSchematic == nil then
		return
	end

	local craftButton = carbineCraft.wndMain:FindChild("CraftingForm"):FindChild("CraftButton")
	if not craftButton:IsEnabled() then
		return
	end]]

	--CraftingLib.GetSchematicInfo(tSchematic.nSchematicId)
	--local tSchematic = --CraftingLib.GetCurrentCraft()
	local tMicrochips, tThresholds = {}
	--local tMicrochips, tThresholds = Apollo.GetAddon("Crafting").luaSchematic:HelperGetUserSelection()
	--local nSchematicId = tSchematicInfo.nSchematicId--tSchematic.nSchematicId
	local patternToSave = {}
	local itemsToCraft = tonumber(wndParent:FindChild("ItemsNumber"):GetText())
	patternToSave.nSchematicId = nSchematicId
	patternToSave.strSchematicName = tSchematicInfo.strName
	patternToSave.Power = ViragsAutoCircuit.Power	
	patternToSave.SoketIndex = SoketIndex
	patternToSave.PickerIndex = PickerIndex
	patternToSave.PropertyIndex = PropertyIndex
	patternToSave.Sokets = Sokets 
	patternToSave.Property = Property
	patternToSave.Picker = Picker 
	patternToSave.tMicrochips = tMicrochips
	patternToSave.tThresholds = tThresholds
	patternToSave.itemsToCraft = itemsToCraft

	local nProperty = {}
	--for k,v in pairs(Property) do
	--	nProperty[k] = {eProperty = v.eProperty, nLayoutLoc = v.nLayoutLoc } 
	--end
	patternToSave.nProperty = nProperty
	--patternToSave.PowerIndex = ViragsAutoCircuit.PowerIndex
	if not self.SavedConfig then self.SavedConfig = {} end
	table.insert(self.SavedConfig, #self.SavedConfig + 1, patternToSave)
	--self:OnClearSokets()
	if nMode ~= MODE_DAILIES then 
		self:OnChangeMode() 
	else
		self:AddPattern() 
	end
end

function ViragsAutoCircuit:OnRemove(wndHandler, wndControl, eMouseButton, index)
	--[[if index then
		--self.SavedConfig[1].wndListItem:Destroy()
		table.remove(self.SavedConfig, index)
		
		self:AddPattern()
		return
	end]]

	local rIndex
	for k, v in pairs(tCurPatterns) do
		if v == self.selectedListItem then
			rIndex = k
		end
	end
	
	if rIndex then
		table.remove(tCurPatterns, rIndex)
		--self.SavedConfig[rIndex].wndListItem:Destroy()
		self.listItemParent = nil
		self.selectedListItem = nil
		self.listItemIndex = nil
	end
	self:AddPattern()	
end

function ViragsAutoCircuit:OnClearQue()
	if nMode == MODE_DAILIES then
		self.SavedConfig = {}
		tCurPatterns = self.SavedConfig
	else
		self.SavedPatterns = {}
		tCurPatterns = self.SavedPatterns 
	end
	self:AddPattern()
end

function ViragsAutoCircuit:OnResizeWnd() 
	if (wndSize == PATTERN_LIST_SMALL) then
		self.wndMain:FindChild(wndNames[PATTERN_LIST_SMALL].patternList):Show(false)
		self.wndMain:FindChild(wndNames[PATTERN_LIST_BIG].patternList):Show(true)
		wndSize = PATTERN_LIST_BIG
	elseif (wndSize == PATTERN_LIST_BIG) then
		self.wndMain:FindChild(wndNames[PATTERN_LIST_SMALL].patternList):Show(true)
		self.wndMain:FindChild(wndNames[PATTERN_LIST_BIG].patternList):Show(false)
		wndSize = PATTERN_LIST_SMALL
	end
	self:ChangeQueueState()
	self:AddPattern()
end

local tSummary = {}


function ViragsAutoCircuit:AddPattern()
	local wndPatternList = self.wndMain:FindChild(wndNames[wndSize].patternList):FindChild("Scroll")
	wndPatternList:DestroyChildren()
	tSummary = {}
	
	for k, v in pairs(tCurPatterns) do
	
		local item  = Apollo.LoadForm(self.xmlDoc, wndNames[wndSize].listItem, wndPatternList, self)
		v.wndListItem = item
		wndPatternList:ArrangeChildrenVert(0)
		
		local offset = 6
		--if wndSize == PATTERN_LIST_SMALL then offset = 7 end 
		local itemLeft, itemTop, itemRight, itemBottom = item:GetAnchorOffsets()
		item:SetAnchorOffsets(itemLeft, itemTop, wndPatternList:GetWidth() - 36, itemTop + itemHeight - offset)

		local tSchematicInfo = CraftingLib.GetSchematicInfo(v.nSchematicId)
		
		v.strTradeskill = kTradeskills[tSchematicInfo.eTradeskillId].strName
		v.eTier = tSchematicInfo.eTier
		v.availableToCraft = self:GetAvailable(v, tSchematicInfo)
		local itemCurrent = tSchematicInfo.itemOutput
		local tItem = itemCurrent:GetDetailedInfo()
		local strIcon = itemCurrent:GetIcon()
		local availableToCraft = v.availableToCraft				
		item:FindChild("QueListItemButton"):SetData(k)
		item:FindChild("Tradeskill"):SetSprite(kTradeskills[tSchematicInfo.eTradeskillId].strIcon)
		item:FindChild("Tradeskill"):SetTooltip(kTradeskills[tSchematicInfo.eTradeskillId].strName)
		item:FindChild("SkillLevel"):SetText(tSchematicInfo.eTier)
		item:FindChild("SkillLevel"):SetTooltip(kTradeskillTiers[tSchematicInfo.eTier])
		item:FindChild("ItemIcon"):SetSprite(strIcon)
		Tooltip.GetItemTooltipForm(self, item:FindChild("ItemIcon"), itemCurrent, {bPrimary = true, bSelling = false})
					
		item:FindChild("AvailableToCraft"):SetText(availableToCraft)
		if availableToCraft == 0 then
			item:FindChild("AvailableToCraft"):SetTextColor("red")	-- Red
		else
			item:FindChild("AvailableToCraft"):SetTextColor("green")	-- Green
		end
		item:FindChild("AvailableToCraft"):SetData(availableToCraft)
		item:SetData(v)
				
		--local powerCore = v.Power[1].h:GetData()
		local wndItemsToCraft = item:FindChild("QueListItemButton"):FindChild("ItemsToCraftBox")
		wndItemsToCraft:SetData(k)
		local itemsToCraft =  v.itemsToCraft
		if not itemsToCraft then itemsToCraft = 3 end
		wndItemsToCraft:SetText(itemsToCraft)
		
		if (wndSize == PATTERN_LIST_BIG) then 
			item:FindChild("SavedSchematic"):SetText(v.strSchematicName)
			Tooltip.GetItemTooltipForm(self, item:FindChild("SavedSchematic"), itemCurrent, {bPrimary = true, bSelling = false})
			local microchips = item:FindChild("Microchips")
			if nMode == MODE_DAILIES then
				self:RefreshMaterialsWnd(microchips, tSchematicInfo, itemsToCraft)
			else 
				self:RefreshMicrochipsWnd(microchips, tSchematicInfo, itemsToCraft, v)
			end
		end	
		self:PopulateSummary(tSchematicInfo, itemsToCraft)		
	end
	
end

function ViragsAutoCircuit:PopulateSummary(tSchematicInfo, itemsToCraft)
	for key, tMaterial in pairs(tSchematicInfo.tMaterials) do	
		local tItem = tSummary[tMaterial.itemMaterial:GetName()]
		if tSummary[tMaterial.itemMaterial:GetName()] == nil then
			tSummary[tMaterial.itemMaterial:GetName()] = { 
				sName = tMaterial.itemMaterial:GetName(),
				tIcon = tMaterial.itemMaterial:GetIcon(),
				nHave = tMaterial.itemMaterial:GetBackpackCount(),
				nNeed = tMaterial.nAmount * itemsToCraft }
		else
			tSummary[tMaterial.itemMaterial:GetName()].nNeed = tItem.nNeed + tMaterial.nAmount * itemsToCraft 
		end
												
	end
	
	local tAvailableCores = CraftingLib.GetAvailablePowerCores(tSchematicInfo.nSchematicId)
	if tAvailableCores then
		local nBackpackCount = 0
		for idx, itemMaterial in pairs(tAvailableCores) do
			--local eItemQuality = itemMaterial:GetItemQuality() or 1
			--if eItemQuality <= 3 then
			nBackpackCount = nBackpackCount + itemMaterial:GetStackCount()
			--end
		end
			
		local strPowerCore = Apollo.GetString("CBCrafting_PowerCore")
		if karPowerCoreTierToString[tSchematicInfo.eTier] then
			strPowerCore = String_GetWeaselString(Apollo.GetString("Tradeskills_AnyPowerCore"), karPowerCoreTierToString[tSchematicInfo.eTier])
		end
		
		local tItem = tSummary[strPowerCore]
		if tItem == nil then
				tSummary[strPowerCore] = { 
				sName = strPowerCore,
				tIcon = "ClientSprites:Icon_ItemMisc_UI_Item_Crafting_PowerCore_Green",
				nHave = nBackpackCount,
				nNeed = itemsToCraft }
		else
			tSummary[strPowerCore].nNeed = tItem.nNeed + itemsToCraft 
		end
	end
end

function ViragsAutoCircuit:RefreshMicrochipsWnd(microchips, tSchematicInfo, itemsToCraft, tSchematic)
	local nPowerCoreId = tSchematic.tMicrochips[1]
	local powerCore = Item.GetDataFromId(nPowerCoreId )
	if powerCore== nil then
		microchips:FindChild("PowerCore"):SetTooltip("Empty.")
	else
		local itemCoreIcon = powerCore:GetIcon()
		if powerCore~= nil then
			microchips:FindChild("PowerCore"):SetText("")
			microchips:FindChild("PowerCore"):SetSprite(itemCoreIcon)
			Tooltip.GetItemTooltipForm(self, microchips:FindChild("PowerCore"), powerCore , {bPrimary = true, bSelling = false})
		end
	end

	local index = 2
	while index <= #tSchematic.tMicrochips do
		local wndMicrochip = microchips:FindChild("Microchip" .. (index - 1))
		if wndMicrochip ~= nil then
			local item = Item.GetDataFromId(tSchematic.tMicrochips[index])

			if item == nil or tSchematic.tMicrochips[index] == 0 then
				wndMicrochip:SetSprite("ClientSprites:GroupRandomLootIcon")
				wndMicrochip:SetTooltip("Random.")
				wndMicrochip:SetBGColor("gray")
			else
				local itemIcon = item:GetIcon()
				local tItemInfo = item:GetMicrochipInfo()
				wndMicrochip:SetBGColor("white")				
				if tItemInfo.eType == Item.CodeEnumMicrochipType.Inductor then
					wndMicrochip:SetBGColor("green")
				elseif tItemInfo.eType == Item.CodeEnumMicrochipType.Capacitor then
					wndMicrochip:SetBGColor("xkcdBrightRed")
				end
				wndMicrochip:SetText(tItemInfo.nBudget)
				wndMicrochip:SetSprite(itemIcon)
				wndMicrochip:SetTooltip(tItemInfo.nBudget .. " " .. tItemInfo.strUnitPropertyName)
				
			end
		end
		index = index + 1
	end	
end

function ViragsAutoCircuit:RefreshMaterialsWnd(microchips, tSchematicInfo, itemsToCraft)
	if (wndSize == PATTERN_LIST_BIG) then
		for key, tMaterial in pairs(tSchematicInfo.tMaterials) do
			if tMaterial.nAmount > 0 then
				local wndMaterial = microchips:FindChild("Microchip" .. (key))
				local nBackpackCount = tMaterial.itemMaterial:GetBackpackCount()
				local sumM = tMaterial.nAmount * itemsToCraft
				local canCraft = math.floor(nBackpackCount/tMaterial.nAmount)
				wndMaterial:SetSprite(tMaterial.itemMaterial:GetIcon())
				wndMaterial:SetText(nBackpackCount .. "/" .. sumM )
				wndMaterial:SetTooltip(tMaterial.itemMaterial:GetName().. " " .. nBackpackCount .. "/" .. sumM .. " Enough for ".. canCraft .. " crafts.")
				--wndMaterial:FindChild("MaterialsName"):SetText(tMaterial.itemMaterial:GetName())
				wndMaterial:FindChild("MaterialsIconNotEnough"):Show(nBackpackCount < (tMaterial.nAmount * itemsToCraft) )
				--self:HelperBuildItemTooltip(wndMaterial, tMaterial.itemMaterial)			
			end
		end	
		local tAvailableCores = CraftingLib.GetAvailablePowerCores(tSchematicInfo.nSchematicId)
		if tAvailableCores then -- Some crafts won't have power cores
			local wndMaterial = microchips:FindChild("PowerCore")
			local nBackpackCount = 0
			for idx, itemMaterial in pairs(tAvailableCores) do
				--local eItemQuality = itemMaterial:GetItemQuality() or 1
				--if eItemQuality <= 3 then
				nBackpackCount = nBackpackCount + itemMaterial:GetStackCount()
				--end
			end
				
			local strPowerCore = Apollo.GetString("CBCrafting_PowerCore")
			if karPowerCoreTierToString[tSchematicInfo.eTier] then
				strPowerCore = String_GetWeaselString(Apollo.GetString("Tradeskills_AnyPowerCore"), karPowerCoreTierToString[tSchematicInfo.eTier])
			end
	
			wndMaterial:SetSprite("ClientSprites:Icon_ItemMisc_UI_Item_Crafting_PowerCore_Green")
			wndMaterial:SetText(nBackpackCount .. "/" .. itemsToCraft)
			wndMaterial:SetTooltip(strPowerCore.. " " .. nBackpackCount .. "/" .. itemsToCraft .. " Enough for ".. nBackpackCount .. " crafts.")
			wndMaterial:FindChild("MaterialsIconNotEnough"):Show(nBackpackCount < itemsToCraft)
		end
	end		
end

function ViragsAutoCircuit:OnSummaryBtn()
	local wndSummary = self.wndMain:FindChild("Summary")
	
	if wndSummary:IsShown() then
		wndSummary:FindChild("Summary"):Show(false)
	else
		wndSummary:Show(true)
	end
	
	self:RefreshSummary()
	
end

function ViragsAutoCircuit:OnSummaryHide() 
	self.wndMain:FindChild("Summary"):Show(false)
end

function ViragsAutoCircuit:OnSummaryRefresh() 	
	self:AddPattern()
	if self.wndMain:FindChild("Summary"):IsVisible() then self:RefreshSummary() end
	
end

function ViragsAutoCircuit:RefreshSummary()
	local wndSummary = self.wndMain:FindChild("Summary")
	local wndSummaryList = self.wndMain:FindChild("SumList")
	
	--local sumLeft, sumTop, sumRight, sumBottom = wndSummary:FindChild("FormBackground"):GetAnchorOffsets()
	--wndSummary:FindChild("FormBackground"):SetAnchorOffsets(sumLeft, sumTop, sumRight, 120)
	wndSummaryList:DestroyChildren()
	
	for key, tMaterial in pairs(tSummary) do
		local item  = Apollo.LoadForm(self.xmlDoc, "SummaryListItem", wndSummaryList, self)
		
		wndSummaryList:ArrangeChildrenVert(0)
		local itemLeft, itemTop, itemRight, itemBottom = item:GetAnchorOffsets()
		local sumListLeft, sumListTop, sumListRight, sumListBottom = wndSummaryList:GetAnchorOffsets()
		local sumLeft, sumTop, sumRight, sumBottom = wndSummary:FindChild("FormBackground"):GetAnchorOffsets()

		item:SetAnchorOffsets(itemLeft, itemTop, itemRight, itemTop + item:GetHeight())
		wndSummaryList:SetAnchorOffsets(sumListLeft, sumListTop, sumListRight, sumListTop + itemTop + item:GetHeight())
		


		local bIsEnough = tMaterial.nHave >= tMaterial.nNeed
		item:FindChild("Icon"):SetSprite(tMaterial.tIcon)
		item:FindChild("Material"):SetText(tMaterial.sName)
		item:FindChild("Have"):SetText(tMaterial.nHave)
		if not bIsEnough then 
			item:FindChild("Have"):SetTextColor("red") 
		else 
			item:FindChild("Have"):SetTextColor("green")
		end
		item:FindChild("Need"):SetText(tMaterial.nNeed)
	end

	local sumListLeft, sumListTop, sumListRight, sumListBottom = wndSummaryList:GetAnchorOffsets()
	local sumLeft, sumTop, sumRight, sumBottom = wndSummary:FindChild("FormBackground"):GetAnchorOffsets()
	wndSummary:FindChild("FormBackground"):SetAnchorOffsets(sumLeft, sumTop, sumRight, sumListBottom + 30)

end



function ViragsAutoCircuit:GetAvailable(tSchematic, tSchematicInfo)
		local bHaveEnoughMats = true
	local available = 9999
	for key, tMaterial in pairs(tSchematicInfo.tMaterials) do
		if tMaterial.nAmount > 0 then
			local nBackpackCount = tMaterial.itemMaterial:GetBackpackCount()

			available = math.min(available, math.floor(nBackpackCount / tMaterial.nAmount))
		end
	end

	local tAvailableCores = CraftingLib.GetAvailablePowerCores(tSchematic.nSchematicId)
	if tAvailableCores then 
		local nBackpackCount = 0
		for idx, itemMaterial in pairs(tAvailableCores) do
			--local eItemQuality = itemMaterial:GetItemQuality() or 1
			--if eItemQuality <= 3 then
			nBackpackCount = nBackpackCount + itemMaterial:GetStackCount()
			--end
		end
		available = math.min(available, nBackpackCount)
	end
	bHasEnoughMaterials = true
	if available == 0 then bHasEnoughMaterials = false end
	return available
end


function ViragsAutoCircuit:OnAdvancedButtonCheck( wndHandler, wndControl, eMouseButton )
	self.wndMain:FindChild("AdvancedCraftSettings"):Show(true)
	self.wndMain:FindChild("AdvancedSettingsBtnCheck"):Show(false)
end

function ViragsAutoCircuit:OnAdvancedButtonUncheck( wndHandler, wndControl, eMouseButton )
	self.wndMain:FindChild("AdvancedCraftSettings"):Show(false)
	self.wndMain:FindChild("AdvancedSettingsBtnCheck"):Show(true)
end

function ViragsAutoCircuit:OnChoseDesiredSpecialBtn( wndHandler, wndControl, eMouseButton )
	local key = wndHandler:GetParent():GetData()
	local special = wndHandler:GetData()
	local wndIcon = tWndSpecials[key]:FindChild("SpecialIcon")
	if special ~= nil then
		tDesiredSpecials[key] = special
		wndIcon:SetSprite("IconSprites:Icon_CraftingUI_Item_Crafting_Special2_Green")
		wndIcon:SetTooltip(special:GetDetailedInfo().tPrimary.tChipInfo.arSpells[1].strFlavor)
	else
		tDesiredSpecials[key] = nil
		wndIcon:SetSprite("CRB_UIKitSprites:spr_iconslotEMPTY")
		wndIcon:SetTooltip("Empty Slot")
	end
	local wndSpecial = self.wndMain:FindChild("Special" .. key)
	wndSpecial:SetCheck(false)
	wndSpecial:FindChild("IsChecked"):Show(false)
	wndSpecial:FindChild("SpecialsPicker"):Show(false)
	self.wndMain:FindChild("DesiredSpecialChooser"):Destroy()
end


function ViragsAutoCircuit:OnDesiredSpecialCheck( wndHandler, wndControl, eMouseButton )
	local wndSpecialChooser = Apollo.LoadForm(self.xmlDoc, 
	"DesiredSpecialChooser", wndHandler:FindChild("SpecialsPicker"), self)
	local wndList = wndSpecialChooser:FindChild("DesiredScroll")
	local specialLeft, specialTop, specialRight, specialBottom = wndSpecialChooser:GetAnchorOffsets()
	local itemLeft, itemTop, itemRight, itemBottom = wndHandler:FindChild("SpecialsPicker"):GetAnchorOffsets()
	wndSpecialChooser:SetAnchorOffsets(specialLeft, itemBottom, specialRight, itemBottom + specialBottom)
	local item = Apollo.LoadForm(self.xmlDoc, "DesiredSpecialListItem", wndList, self)
	item:SetData(wndHandler:GetData())
	
	for id, v in pairs(self.tSchematicSpecials) do
		--v:GetDetailedInfo().tPrimary.tChipInfo.arSpells[1].strFlavor
		item  = Apollo.LoadForm(self.xmlDoc, "DesiredSpecialListItem", wndList, self)
		local itemHeight = item:GetHeight()
		item:FindChild("Text"):SetText(v:GetDetailedInfo().tPrimary.tChipInfo.arSpells[1].strFlavor)
		item:SetData(wndHandler:GetData())
		item:FindChild("ChoseDesiredSpecialBtn"):SetData(v)
		wndList:ArrangeChildrenVert(0)
		local itemLeft, itemTop, itemRight, itemBottom = item:GetAnchorOffsets()
		local sumListLeft, sumListTop, sumListRight, sumListBottom = wndList:GetAnchorOffsets()
		local sumLeft, sumTop, sumRight, sumBottom = wndSpecialChooser:FindChild("BGForm"):GetAnchorOffsets()

		item:SetAnchorOffsets(itemLeft, itemTop, itemRight, itemTop + itemHeight)
		--wndList:SetAnchorOffsets(sumListLeft, sumListTop, sumListRight, sumListTop + itemTop + itemHeight)
		--wndSpecialChooser:FindChild("BGForm"):SetAnchorOffsets(sumLeft, sumTop, sumRight, sumTop + sumListTop + itemTop + itemHeight * 1.25)
	end

	wndHandler:FindChild("IsChecked"):Show(true)
	wndHandler:FindChild("SpecialsPicker"):Show(true)
end

function ViragsAutoCircuit:OnDesiredSpecialUncheck( wndHandler, wndControl, eMouseButton )
	local wndSpecialChooser = self.wndMain:FindChild("DesiredSpecialChooser")
	if wndSpecialChooser ~= nil then
		wndSpecialChooser:Destroy()
	end
	wndHandler:FindChild("IsChecked"):Show(false)
	wndHandler:FindChild("SpecialsPicker"):Show(false)
end

function ViragsAutoCircuit:RefreshDesiredPowerCores( tSpecials )

	self.wndMain:FindChild("AdvancedCraftSettings"):Show(false)
	self.wndMain:FindChild("AdvancedSettingsBtnCheck"):Show(true)
end

function ViragsAutoCircuit:OnDesiredPowerCheck( wndHandler, wndControl, eMouseButton )
	local key = wndHandler:GetData()
	tDesiredCores[key] = tDesiredPowerCoreTypes[key]

	--table.insert(tDesiredCores, key, tDesiredPowerCoreTypes[key])
	wndHandler:FindChild("IsChecked"):Show(true)
end

function ViragsAutoCircuit:OnDesiredPowerUncheck( wndHandler, wndControl, eMouseButton )
	local key = wndHandler:GetData()
	--table.remove(tDesiredCores, key)

	tDesiredCores[key] = nil
	wndHandler:FindChild("IsChecked"):Show(false)

end

function ViragsAutoCircuit:OnCraftingCloseBtn(wndHandler, wndControl)
	local virA = Apollo.GetAddon("ViragsAutoCircuit")
	if virA then virA.wndMain:Show(false) end
	if wndHandler ~= wndControl then
		return
	end

	self:ExitAndReset()

	local tCurrentCraft = CraftingLib.GetCurrentCraft()
	if tCurrentCraft and tCurrentCraft.nSchematicId ~= 0 then
		Event_FireGenericEvent("GenericEvent_LootChannelMessage", Apollo.GetString("CoordCrafting_CraftingInterrupted"))
	end
	Event_FireGenericEvent("AlwaysShowTradeskills")
end


-----------------------------------------------------------------------------------------------
-- Save Patterns End
-----------------------------------------------------------------------------------------------

function ViragsAutoCircuit:OnSave(eType)
    if eType ~= GameLib.CodeEnumAddonSaveLevel.Realm then
        return nil
    end 
	local save = { SavedPatterns = self.SavedPatterns }
	local posLeft, posTop = self.wndMain:GetPos()
	save.mainPosition = { left = posLeft, top = posTop }
	save.bUseDesiredCore = self.wndMain:FindChild("DesiredPowerCheckBox"):IsChecked()
	--save.bAbandonOnDesired = self.wndMain:FindChild("AbandonCraftCheckBox"):IsChecked()
	save.bCountRuneSlots = self.wndMain:FindChild("RuneSlotsCheckbox"):IsChecked()
	save.nRuneCount = tonumber(self.wndRuneCount:GetText())
	save.tDesiredCores = {}
	save.nMode = nMode
	save.bStayOnTop = bStayOnTop
	
	
	for k,  v in pairs(tDesiredCores) do
		save.tDesiredCores[k] = v 
	end
	save.wndSize = wndSize
    return save
end

function ViragsAutoCircuit:OnRestore(eType, tData)
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Realm then
        return nil
    end 
	if tData.mainPosition ~= nil then
        self.wndMain:Move(tData.mainPosition.left, tData.mainPosition.top, self.wndMain:GetWidth(), self.wndMain:GetHeight())
    end
	if tData.wndSize ~= nil then
		wndSize = tData.wndSize
	end
	
	if tData.tDesiredCores ~= nil then
		tDesiredCores = tData.tDesiredCores
	end
	
	if tData.bUseDesiredCore ~= nil then
		bUseDesiredCore = tData.bUseDesiredCore
	end
	
	--[[if tData.bAbandonOnDesired ~= nil then
		bAbandonOnDesired = tData.bAbandonOnDesired
	end]]
	
	if tData.bCountRuneSlots ~= nil then
		bCountRuneSlots = tData.bCountRuneSlots
	end
	
	if tData.nRuneCount ~= nil then
		nRuneCount = tData.nRuneCount
	end

	if tData.SavedPatterns ~= nil then
		self.SavedPatterns = tData.SavedPatterns
	end
	
	if tData.nMode ~= nil then
		nMode = tData.nMode
	end
	
	if tData.bStayOnTop ~= nil then
		bStayOnTop = tData.bStayOnTop
	end

	tSummary = {}
	--self.SavedConfig = tData.SavedConfig
end

--[[function ViragsAutoCircuit:OnMouseDown( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
end]]


---------------------------------------------------------------------------------------------------
-- PatternListItem Functions
---------------------------------------------------------------------------------------------------

function ViragsAutoCircuit:OnQueListItemCheck(wndHandler, wndControl, eMouseButton)
	--wndHandler:FindChild("Background"):SetBGColor("AddonLoaded")
	--wndHandler:FindChild("Checked"):Show(true)
	self.listItemIndex = wndHandler:GetData()
	self.listItemParent = wndHandler:GetParent()
	self.selectedListItem = self.listItemParent:GetData()
	local wndPicker = self.listItemParent:FindChild("QueuePicker")
	wndPicker:Show(true)
	wndPicker:SetData(self.listItemIndex)
	local bCheckUp = self:CheckQueueKey(self.listItemIndex, -1)
	local bCheckDown = self:CheckQueueKey(self.listItemIndex, 1)
	if bCheckUp == false and bCheckDown == false then
		wndPicker:Show(false)
	elseif bCheckUp == false then
		wndPicker:FindChild("PickerUp"):Show(false)
	elseif self:CheckQueueKey(self.listItemIndex, 1) == false then
		wndPicker:FindChild("PickerDown"):Show(false)
	end
	
	if nMode ~= MODE_DAILIES then
		self:CheckSpecials(CraftingLib.GetSchematicInfo(self.SavedPatterns[self.listItemIndex].nSchematicId))
	end
end

function ViragsAutoCircuit:OnQueListItemUncheck(wndHandler, wndControl, eMouseButton)
	--wndHandler:FindChild("Background"):SetBGColor("ItemQuality_Good")
	--wndHandler:FindChild("Checked"):Show(false)
	wndHandler:GetParent():FindChild("QueuePicker"):Show(false)
	self.listItemIndex = nil
	self.listItemParent = nil
	self.selectedListItem = nil
	
end


function ViragsAutoCircuit:OnQueuePickerDown( wndHandler, wndControl, eMouseButton )
	local wndPatternList = self.wndMain:FindChild(wndNames[wndSize].patternList):FindChild("Scroll")
	local wndParent = wndHandler:GetParent()
	local key = wndParent:GetData()
	local swap = tCurPatterns[key +1]
	tCurPatterns[key +1] = tCurPatterns[key]
	tCurPatterns[key] = swap
	local offset = 6
	--if wndSize == PATTERN_LIST_SMALL then offset = 7 end
	local currentPosition = wndPatternList:GetVScrollPos() + (itemHeight - offset) 
	--wndParent:GetParent():FindChild("QueListItemButton"):SetCheck(true)
	local wndBtn2 = tCurPatterns[key].wndListItem:FindChild("QueListItemButton")
	self:OnQueListItemUncheck(wndBtn2, wndBtn2)
	self:AddPattern()
	local wndBtn1 = tCurPatterns[key+1].wndListItem:FindChild("QueListItemButton")
	wndPatternList:SetVScrollPos(currentPosition)
	wndBtn1:SetCheck(true)
	self:OnQueListItemCheck(wndBtn1, wndBtn1)
end

function ViragsAutoCircuit:OnQueuePickerUp( wndHandler, wndControl, eMouseButton )
	local wndPatternList = self.wndMain:FindChild(wndNames[wndSize].patternList):FindChild("Scroll")
	local wndParent = wndHandler:GetParent()
	local key = wndParent:GetData()
	local swap = tCurPatterns[key -1]
	tCurPatterns[key -1] = tCurPatterns[key]
	tCurPatterns[key] = swap
	local offset = 6
	--if wndSize == PATTERN_LIST_SMALL then offset = 7 end
	local currentPosition = wndPatternList:GetVScrollPos() - (itemHeight - offset)
	
	local wndBtn2 = tCurPatterns[key].wndListItem:FindChild("QueListItemButton")
	self:OnQueListItemUncheck(wndBtn2, wndBtn2)
	self:AddPattern()
	local wndBtn1 = tCurPatterns[key-1].wndListItem:FindChild("QueListItemButton")
	wndPatternList:SetVScrollPos(currentPosition)
	wndBtn1:SetCheck(true)
	self:OnQueListItemCheck(wndBtn1, wndBtn1)
end

function ViragsAutoCircuit:CheckQueueKey(key, value)
	
	if value > 0 then
		if key+value <= #tCurPatterns then
			return true
		else 
			return false
		end
	else 
		if key+value >= 1 then
			return true
		else 
			return false
		end
	end
end

function ViragsAutoCircuit:OnWndMouseEnter( wndHandler, wndControl, x, y )
	if wndHandler:GetName() == "RefreshSprite" then
		wndHandler:SetBGColor("yellow")
	end

end

function ViragsAutoCircuit:OnWndMouseExit( wndHandler, wndControl, x, y )
	if wndHandler:GetName() == "RefreshSprite" then
		wndHandler:SetBGColor("white")
	end

end

---------------------------------------------------------------------------------------------------
-- SchematicsOverlay Functions
---------------------------------------------------------------------------------------------------

function ViragsAutoCircuit:OnSaveSchematic( wndHandler, wndControl, eMouseButton )
	self.wndMain:FindChild("PatternsButton"):SetCheck(true)
	self:OnPatternsButtonCheck()
	self.wndMain:Show(true)

	local tSchematicInfo = nil
	local nSchematicId 	= nil
	local wndParent = wndHandler:GetParent()
	local carbineCraft = Apollo.GetAddon("Crafting")
	local altself = Apollo.GetAddon("Crafting").luaSchematic	
	local tSchematic = CraftingLib.GetCurrentCraft()
	tSchematicInfo = altself.tSchematicInfo

	--[[if tSchematic == nil then
		return
	end

	local craftButton = carbineCraft.wndMain:FindChild("CraftingForm"):FindChild("CraftButton")
	if not craftButton:IsEnabled() then
		return
	end]]

	--CraftingLib.GetSchematicInfo(tSchematic.nSchematicId)
	--local tSchematic = --CraftingLib.GetCurrentCraft()
	local tMicrochips, tThresholds = Apollo.GetAddon("Crafting").luaSchematic:HelperGetUserSelection()
	--local nSchematicId = tSchematicInfo.nSchematicId--tSchematic.nSchematicId
	
	local patternToSave = {}
	patternToSave.nSchematicId = tSchematicInfo.nSchematicId
	patternToSave.strSchematicName = tSchematicInfo.strName
	patternToSave.Power = ViragsAutoCircuit.Power	
	patternToSave.SoketIndex = SoketIndex
	patternToSave.PickerIndex = PickerIndex
	patternToSave.PropertyIndex = PropertyIndex
	patternToSave.Sokets = Sokets 
	patternToSave.Property = Property
	patternToSave.Picker = Picker 
	patternToSave.tMicrochips = tMicrochips
	patternToSave.tThresholds = tThresholds
	patternToSave.itemsToCraft = 0
	
	local nProperty = {}
	--for k,v in pairs(Property) do
	--	nProperty[k] = {eProperty = v.eProperty, nLayoutLoc = v.nLayoutLoc } 
	--end
	patternToSave.nProperty = nProperty
	--patternToSave.PowerIndex = ViragsAutoCircuit.PowerIndex
	if not self.SavedPatterns then self.SavedPatterns = {} end
	table.insert(self.SavedPatterns, 1, patternToSave)
	--self:OnClearSokets()
	if nMode == MODE_DAILIES then 
		self:OnChangeMode() 
	else
		self:AddPattern() 
	end
end

---------------------------------------------------------------------------------------------------
-- RepeatOverlay Functions
---------------------------------------------------------------------------------------------------

function ViragsAutoCircuit:OnRepeatLastCraft( wndHandler, wndControl, eMouseButton )
	self.Power = tTempQueue.Power
	self.PowerIndex = 1
	Property = tTempQueue.Property
	PropertyIndex = tTempQueue.PropertyIndex
	self.Count = 1
	bRepeatLastCraft = true
	self:StartCrafting(nLastCraftSchemId)
end

function ViragsAutoCircuit:SendVarToRover( sTag, tTable)
	SendVarToRover(sTag, tTable, Apollo.GetAddon("Rover").ADD_ALL)
end

-----------------------------------------------------------------------------------------------
-- ViragsAutoCircuit Instance
-----------------------------------------------------------------------------------------------
local ViragsAutoCircuitInst = ViragsAutoCircuit:new()
ViragsAutoCircuitInst:Init()
